# $Revision: 1.441.2.1558.2.164 $, $Date: 2009/08/18 02:09:41 $
# TODO:
#   - test pax stuff (btw. tested ok in softmode)
#   - prepare config for non SEGMEXEC capable archs (ie not x86/32bit)
#   - patch scripts/Makefile.xen not to require bash
#   - make PAE usage configurable when Xen is on
#		ALL
#   - #vserver: try to get a 2.2.x kernel patch or if you like development
#     features a 2.3.x one instead of the long discontinued 2.1.x you are using
#   - with xen0/xenU does not compile due to cyrix-specific changes in 2.6.16.61:
#     http://git.kernel.org/?p=linux/kernel/git/stable/linux-2.6.16.y.git;a=commitdiff;h=69731ebbb3d2283c2c33a2bf262d785e2362b876
#
#
# WARNING: Kernels from 2.6.16.X series not work under OldWorldMac
#
# Conditional build:
%bcond_without	smp		# don't build SMP kernel
%bcond_without	up		# don't build UP kernel
%bcond_without	source		# don't build kernel-source package
%bcond_without	pcmcia		# don't build pcmcia

%bcond_with	grsec_full	# build full grsecurity
%bcond_with	pax		# build PaX and full grsecurity
%bcond_with	verbose		# verbose build (V=1)
%bcond_with	xen0		# added Xen0 support
%bcond_with	xenU		# added XenU support
%bcond_without	grsecurity	# don't build grsecurity at all
%bcond_without	grsec_minimal	# build only minimal subset (proc,link,fifo,shm)

%bcond_without	bootsplash	# build with bootsplash instead of fbsplash
%bcond_with	vesafb_tng	# vesafb-tng, vesafb replacement from gentoo
%bcond_with	pae		# build PAE (HIGHMEM64G) support on uniprocessor
%bcond_with	nfsroot		# build with root on NFS support
%bcond_with	reiserfs4	# build with ReiserFS 4 support
%bcond_with	ext2compiled	# compile ext2 into kernel to be able to boot from ext2 rootfs
%bcond_with     abi             # build ABI support only ix86 !!

%{?debug:%define with_verbose 1}

%if %{without grsecurity}
%undefine	with_grsec_full
%undefine	with_grsec_minimal
%undefine	with_pax
%endif

%if %{with pax}
%undefine	with_grsec_minimal
%undefine	with_grsec_full
%define		with_grsecurity		1
%endif

%if %{with grsec_full}
%undefine	with_grsec_minimal
%define		with_grsecurity		1
%endif

%if %{with grsec_minimal}
%undefine	with_grsec_full
%undefine	with_pax
%define		with_grsecurity		1
%endif

%ifarch sparc
# sparc32 is missing important updates from 2.5 cycle - won't build.
%undefine	with_smp
%endif

%ifarch ia64
# broken
%undefine	with_up
%endif

%define		have_drm	1
%define		have_oss	1
%define		have_sound	1

%ifarch %{ix86} alpha ppc
%define		have_isa	1
%else
%define		have_isa	0
%endif

%ifarch sparc sparc64
%undefine	with_pcmcia
%define		have_drm	0
%define		have_oss	0
%endif

%ifnarch %{ix86}
%undefine       abi
%endif

%if %{with xen0} || %{with xenU}
%define		with_pae	1
%define		with_xen	1
%endif

## Programs required by kernel to work.
%define		_binutils_ver		2.12.1
%define		_util_linux_ver		2.10o
%define		_module_init_tool_ver	0.9.10
%define		_e2fsprogs_ver		1.29
%define		_jfsutils_ver		1.1.3
%define		_reiserfsprogs_ver	3.6.3
%define		_reiser4progs_ver	1.0.0
%define		_xfsprogs_ver		2.6.0
%define		_pcmcia_cs_ver		3.1.21
%define		_pcmciautils_ver	004
%define		_quota_tools_ver	3.09
%define		_ppp_ver		1:2.4.0
%define		_isdn4k_utils_ver	3.1pre1
%define		_nfs_utils_ver		1.0.5
%define		_procps_ver		3.2.0
%define		_oprofile_ver		0.9
%define		_udev_ver		071
%define		_mkvmlinuz_ver		1.3

%define		netfilter_snap		20060504

%define		_enable_debug_packages			0

%define		squashfs_version	3.1
%define		suspend_version		2.2.5

%define		xen_hv_abi			3.0

%define		__alt_kernel	%{?with_pax:pax}%{?with_grsec_full:grsecurity}%{?with_xen0:xen0}%{?with_xenU:xenU}%{!?with_xen:%{?with_pae:pae}}
%if "%{__alt_kernel}" != ""
%define		alt_kernel	%{__alt_kernel}
%endif

# Our Kernel ABI, increase this when you want the out of source modules being rebuilt
# Usually same as %{_rel}
%define		KABI		1

# kernel release (used in filesystem and eventually in uname -r)
# modules will be looked from /lib/modules/%{kernel_release}%{?smp}
# _localversion is just that without version for "> localversion"
%define		_localversion %{KABI}
%define		kernel_release %{version}%{?alt_kernel:_%{alt_kernel}}-%{_localversion}

%define		_basever	2.6.16
%define		_postver	.62
%define		_rel		3
Summary:	The Linux kernel (the core of the Linux operating system)
Summary(de.UTF-8):	Der Linux-Kernel (Kern des Linux-Betriebssystems)
Summary(et.UTF-8):	Linuxi kernel (ehk operatsioonisüsteemi tuum)
Summary(fr.UTF-8):	Le Kernel-Linux (La partie centrale du systeme)
Summary(pl.UTF-8):	Jądro Linuksa
Name:		kernel%{_alt_kernel}
Version:	%{_basever}%{_postver}
Release:	%{_rel}%{?with_ext2compiled:ext2}
Epoch:		3
License:	GPL v2
Group:		Base/Kernel
Source0:	http://www.kernel.org/pub/linux/kernel/v2.6/linux-%{_basever}.tar.bz2
# Source0-md5:	9a91b2719949ff0856b40bc467fd47be
Source1:	kernel-autoconf.h
Source2:	kernel-config.h
Source3:	http://www.kernel.org/pub/linux/kernel/v2.6/patch-%{version}.bz2
# Source3-md5:	65e7b7a48bbef41ea1e3702e139b3411

Source5:	kernel-ppclibs.Makefile
Source7:	kernel-module-build.pl

Source10:	http://suspend2.net/downloads/all/suspend2-%{suspend_version}-for-2.6.16.9.tar.bz2
# Source10-md5:	34345b1f7ad1505f6b264427a21e8a04
Source12:	ftp://ftp.namesys.com/pub/reiser4-for-2.6/2.6.16/reiser4-for-2.6.16-5.patch.gz
# Source12-md5:	6ad22d084e12257781f205ec248e4f64

Source20:	kernel-i386.config
Source21:	kernel-i386-smp.config
Source22:	kernel-x86_64.config
Source23:	kernel-x86_64-smp.config
Source24:	kernel-sparc.config
Source25:	kernel-sparc-smp.config
Source26:	kernel-sparc64.config
Source27:	kernel-sparc64-smp.config
Source28:	kernel-alpha.config
Source29:	kernel-alpha-smp.config
Source30:	kernel-ppc.config
Source31:	kernel-ppc-smp.config
Source32:	kernel-ia64.config
Source33:	kernel-ia64-smp.config

Source40:	kernel-netfilter.config
Source41:	kernel-squashfs.config
Source42:	kernel-suspend2.config
Source43:	kernel-vserver.config
Source44:	kernel-vesafb-tng.config
Source45:	kernel-grsec.config
Source46:	kernel-xen0.config
Source47:	kernel-xenU.config
Source48:	kernel-xen-extra.config
Source49:	kernel-grsec+pax.config
Source50:	kernel-openswan.config
Source51:	kernel-abi.config
###
#	Patches
###

#
# PATA ports on SATA Promise controller; patch based on:
# http://cvs.fedora.redhat.com/viewcvs/*checkout*/rpms/kernel/devel/linux-2.6-sata-promise-pata-ports.patch
#
Patch1:		linux-2.6-sata-promise-pata-ports.patch

# tahoe9XX http://tahoe.pl/drivers/tahoe9xx-2.6.11.5.patch
Patch2:		tahoe9xx-2.6.11.5.patch

#	ftp://ftp.openbios.org/pub/bootsplash/kernel/bootsplash-3.1.6-2.6.15.diff
Patch3:		bootsplash-3.1.6-2.6.15.diff
#	http://dev.gentoo.org/~spock/projects/gensplash/archive/fbsplash-0.9.2-r5-2.6.16.patch
Patch4:		fbsplash-0.9.2-r5-2.6.16.patch
Patch5:		linux-2.6-vesafb-tng.patch

# directly from http://mesh.dl.sourceforge.net/sourceforge/squashfs/squashfs3.1.tar.gz
#		from linux-2.6.16
Patch6:		squashfs%{squashfs_version}-patch

Patch7:		linux-alpha-isa.patch
Patch8:		linux-fbcon-margins.patch
Patch9:		linux-static-dev.patch

# netfilter snap
## submitted

## base
Patch10:	pom-ng-IPV4OPTSSTRIP-%{netfilter_snap}.patch
Patch11:	pom-ng-connlimit-%{netfilter_snap}.patch
Patch12:	pom-ng-expire-%{netfilter_snap}.patch
Patch13:	pom-ng-fuzzy-%{netfilter_snap}.patch
Patch14:	pom-ng-ipv4options-%{netfilter_snap}.patch
Patch15:	pom-ng-nth-%{netfilter_snap}.patch
Patch16:	pom-ng-osf-%{netfilter_snap}.patch
Patch17:	pom-ng-psd-%{netfilter_snap}.patch
Patch18:	pom-ng-quota-%{netfilter_snap}.patch
Patch19:	pom-ng-random-%{netfilter_snap}.patch
Patch20:	pom-ng-set-%{netfilter_snap}.patch
Patch21:	pom-ng-time-%{netfilter_snap}.patch
Patch22:	pom-ng-u32-%{netfilter_snap}.patch

## extra
Patch30:	pom-ng-ACCOUNT-%{netfilter_snap}.patch
Patch31:	pom-ng-IPMARK-%{netfilter_snap}.patch
Patch32:	pom-ng-ROUTE-%{netfilter_snap}.patch
Patch33:	pom-ng-TARPIT-%{netfilter_snap}.patch
Patch34:	pom-ng-XOR-%{netfilter_snap}.patch
Patch35:	pom-ng-account-%{netfilter_snap}.patch
Patch36:	ipp2p-0.8.2.patch
Patch37:	pom-ng-rpc-%{netfilter_snap}.patch
Patch38:	pom-ng-unclean-%{netfilter_snap}.patch
Patch39:	linux-2.6-conntrack_sip_svn20060804.patch

###
#	End netfilter
###

# from http://ace-host.stuart.id.au/russell/files/debian/sarge/kernel-patch-linuxabi/kernel-patch-linuxabi_20060404.tar.gz
Patch40:	linuxabi-2.6.16-0.patch

# derived from http://dl.sourceforge.net/l7-filter/netfilter-layer7-v2.2.tar.gz
Patch49:	kernel-2.6.13-2.6.16-layer7-2.2.patch

# from http://www.linuximq.net/patchs/linux-2.6.16-imq2.diff
Patch50:	linux-2.6.16-imq2.diff

# from http://bluetooth-alsa.sourceforge.net/sco-mtu.patch
Patch51:	sco-mtu.patch

# esfq
# from http://fatooh.org/esfq-2.6/current/esfq-kernel.patch
Patch53:	esfq-kernel.patch

Patch54:	linux-iforce-trust_ffrm.patch
# by Baggins request:
# derived from ftp://ftp.cmf.nrl.navy.mil/pub/chas/linux-atm/vbr/vbr-kernel-diffs
Patch55:	linux-2.6-atm-vbr.patch
Patch56:	linux-2.6-atmdd.patch

Patch57:	linux-2.6-cpuset_virtualization.patch

# Derived from http://www.skd.de/e_en/products/adapters/pci_64/sk-98xx_v20/software/linux/driver/install-8_31.tar.bz2
Patch60:	linux-2.6-sk98lin-8.31.2.3.patch

Patch70:	linux-2.6-suspend2-avoid-redef.patch
Patch71:	linux-2.6-suspend2-page.patch
Patch72:	suspend2-2.2.5-for-2.6.16.37-fix.patch

Patch80:	kernel-ahci-sb600.patch

Patch81:	linux-2.6-md.patch
Patch82:	linux-3w-9xxx.patch

# From http://www.broadcom.com/support/ethernet_nic/driver-sla.php?driver=570x-Linux
Patch83:	linux-tg3-3.81c.patch

# ICH9 from kernel-2.6.17.17mdv from Mandriva
Patch85:	linux-2.6-i2ci801_ich9.patch
Patch86:	linux-2.6-sata-ich9.patch

# IPSEC KLIPS
Patch90:	http://www.openswan.org/download/openswan-2.4.9.kernel-2.6-klips.patch.gz
Patch91:	http://www.openswan.org/download/openswan-2.4.9.kernel-2.6-natt.patch.gz
Patch92:	linux-asm_segment_h.patch

# vserver from: http://vserver.13thfloor.at/Experimental/patch-2.6.16-vs2.1.1-rc15.diff
Patch100:	linux-2.6-vs2.1.patch
Patch101:	linux-2.6-vs2.1-suspend2.patch
Patch102:	linux-2.6-vs2.1-128IPs.patch
Patch103:	linux-vcontext-selinux.patch
Patch104:	kernel-CVE-2008-0163.patch
Patch105:	kernel-CVE-2009-2692.patch

# from http://www.cl.cam.ac.uk/Research/SRG/netos/xen/downloads/xen-3.0.2-src.tgz
#Patch120:	kernel-xen.patch
Patch120:	xen-3.0-2.6.16.patch
Patch121:	linux-xen-page_alloc.patch
Patch122:	kernel-xen-sparse-nv.patch

# from  http://www.hpl.hp.com/personal/Jean_Tourrilhes/Linux/iw266_we20-6.diff
Patch140:	linux-2.6.16-we20-6.patch

Patch200:	linux-2.6-ppc-ICE-hacks.patch
Patch201:	linux-2.6-x86_64-stack-protector.patch
Patch202:	linux-2.6-unwind-through-signal-frames.patch

# nForce ethernet driver forcedeth and newer nvidia sata drivers from nvidia's website
Patch250:	linux-nvidia.patch

# From ALSA 1.0.13 for nVidia
Patch252:	linux-alsa-hda.patch

# add tty ioctl to figure physical device of the console. used by showconsole.spec (blogd)
Patch256:	kernel-TIOCGDEV.patch

# HP/Compaq cciss driver
Patch260:	linux-2.6-cciss-3.6.18.patch

Patch1000:	linux-2.6-grsec-minimal.patch
Patch1001:	linux-2.6-grsec-wrong-deref.patch

Patch1200:	linux-2.6-apparmor.patch
Patch1201:	linux-2.6-apparmor-caps.patch

# grsecurity snap for 2.6.16.14
# based on http://www.grsecurity.net/~spender/grsecurity-2.1.9-2.6.16.14-200605060936.patch
Patch9999:	grsecurity-2.1.9-2.6.16.14.patch
Patch10000:	linux-2.6-grsec-caps.patch

URL:		http://www.kernel.org/
%if %{with xen0} || %{with xenU}
BuildRequires:	bash
%endif
BuildRequires:	binutils >= 3:2.14.90.0.7
%ifarch sparc sparc64
BuildRequires:	elftoaout
%endif
BuildRequires:	/sbin/depmod
BuildRequires:	gcc >= 5:3.2
BuildRequires:	net-tools
BuildRequires:	perl-base
BuildRequires:	rpm-build >= 4.4.9-56
BuildRequires:	rpmbuild(macros) >= 1.217
Autoreqprov:	no
Requires(post):	coreutils
Requires(post):	geninitrd >= 2.57
Requires(post):	module-init-tools >= 0.9.9
Requires:	/sbin/depmod
Requires:	coreutils
Requires:	geninitrd >= 2.57
Requires:	module-init-tools >= 0.9.9
Provides:	%{name}(netfilter) = %{netfilter_snap}
Provides:	%{name}(vermagic) = %{kernel_release}
Provides:	%{name}-up = %{epoch}:%{version}-%{release}
%if %{with xen0}
Requires:	xen-hypervisor-abi = %{xen_hv_abi}
%endif
Obsoletes:	kernel-misc-fuse
Obsoletes:	kernel-modules
Obsoletes:	kernel-net-hostap
Obsoletes:	kernel-net-ieee80211
Obsoletes:	kernel-net-ipp2p
Conflicts:	e2fsprogs < %{_e2fsprogs_ver}
Conflicts:	isdn4k-utils < %{_isdn4k_utils_ver}
Conflicts:	jfsutils < %{_jfsutils_ver}
Conflicts:	module-init-tool < %{_module_init_tool_ver}
Conflicts:	nfs-utils < %{_nfs_utils_ver}
Conflicts:	oprofile < %{_oprofile_ver}
Conflicts:	ppp < %{_ppp_ver}
Conflicts:	procps < %{_procps_ver}
Conflicts:	quota-tools < %{_quota_tools_ver}
%if %{with reiserfs4}
Conflicts:	reiser4progs < %{_reiser4progs_ver}
%endif
Conflicts:	reiserfsprogs < %{_reiserfsprogs_ver}
Conflicts:	udev < %{_udev_ver}
Conflicts:	util-linux < %{_util_linux_ver}
Conflicts:	xfsprogs < %{_xfsprogs_ver}
%if %{with xen} || %{with pae}
ExclusiveArch:	%{ix86} %{?with_xen:%{x8664}}
ExcludeArch:	i386 i486 i586
%else
ExclusiveArch:	%{ix86} alpha %{x8664} ia64 ppc ppc64 sparc sparc64
%endif
ExclusiveOS:	Linux
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# No ELF objects there to strip (skips processing 27k files)
%define		_noautostrip	.*%{_kernelsrcdir}/.*
%define		_noautochrpath	.*%{_kernelsrcdir}/.*

%ifarch ia64
%define		initrd_dir	/boot/efi
%else
%define		initrd_dir	/boot
%endif

%define		_kernelsrcdir	/usr/src/linux%{_alt_kernel}-%{version}

%if "%{_target_base_arch}" != "%{_arch}"
	%define	CrossOpts ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux-
	%define	DepMod /bin/true

	%if "%{_arch}" == "sparc" && "%{_target_base_arch}" == "sparc64"
	%define CrossOpts ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- LD=%{__ld} AS=%{__as} NM=%{__nm} AR=%{__ar} RANLIB=%{__ranlib} STRIP=%{__strip}
	%define	DepMod /sbin/depmod
	%endif

	%if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"
	%define	CrossOpts ARCH=%{_target_base_arch}
	%define	DepMod /sbin/depmod
	%endif

%else
	%define CrossOpts CC="%{__cc}"
	%define	DepMod /sbin/depmod
%endif

%description
This package contains the Linux kernel that is used to boot and run
your system. It contains few device drivers for specific hardware.
Most hardware is instead supported by modules loaded after booting.

Netfilter module dated: %{netfilter_snap}
%{?with_grsec_full:Grsecurity full support - enabled}
%{?with_pax:PaX support - enabled}
%{?with_xen0:Xen 0 - enabled}
%{?with_xenU:Xen U - enabled}
%{?with_vesafb_tng:VesaFB New generation - enabled}
%{?with_nfsroot:Root on NFS - enabled}

%description -l de.UTF-8
Das Kernel-Paket enthält den Linux-Kernel (vmlinuz), den Kern des
Linux-Betriebssystems. Der Kernel ist für grundliegende
Systemfunktionen verantwortlich: Speicherreservierung,
Prozeß-Management, Geräte Ein- und Ausgaben, usw.

Netfilter module dated: %{netfilter_snap}
%{?with_grsec_full:Grsecurity full support - enabled}
%{?with_pax:PaX support - enabled}
%{?with_xen0:Xen 0 - enabled}
%{?with_xenU:Xen U - enabled}
%{?with_vesafb_tng:VesaFB New generation - enabled}
%{?with_nfsroot:Root on NFS - enabled}

%description -l fr.UTF-8
Le package kernel contient le kernel linux (vmlinuz), la partie
centrale d'un système d'exploitation Linux. Le noyau traite les
fonctions basiques d'un système d'exploitation: allocation mémoire,
allocation de process, entrée/sortie de peripheriques, etc.

Netfilter module dated: %{netfilter_snap}
%{?with_grsec_full:Grsecurity full support - enabled}
%{?with_pax:PaX support - enabled}
%{?with_xen0:Xen 0 - enabled}
%{?with_xenU:Xen U - enabled}
%{?with_vesafb_tng:VesaFB New generation - enabled}
%{?with_nfsroot:Root on NFS - enabled}

%description -l pl.UTF-8
Pakiet zawiera jądro Linuksa niezbędne do prawidłowego działania
Twojego komputera. Zawiera w sobie sterowniki do sprzętu znajdującego
się w komputerze, takiego jak sterowniki dysków itp.

Netfilter module dated: %{netfilter_snap}
%{?with_grsec_full:Grsecurity full support - enabled}
%{?with_pax:PaX support - enabled}
%{?with_xen0:Xen 0 - enabled}
%{?with_xenU:Xen U - enabled}
%{?with_vesafb_tng:VesaFB New generation - enabled}
%{?with_nfsroot:Root on NFS - enabled}
%{?with_abi:Linux ABI support - enabled}

%package vmlinux
Summary:	vmlinux - uncompressed kernel image
Summary(pl.UTF-8):	vmlinux - rozpakowany obraz jądra
Group:		Base/Kernel

%description vmlinux
vmlinux - uncompressed kernel image.

%description vmlinux -l pl.UTF-8
vmlinux - rozpakowany obraz jądra.

%package drm
Summary:	DRM kernel modules
Summary(pl.UTF-8):	Sterowniki DRM
Group:		Base/Kernel
Requires(postun):	%{name}-up = %{epoch}:%{version}-%{release}
Requires:	%{name}-up = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description drm
DRM kernel modules.

%description drm -l pl.UTF-8
Sterowniki DRM.

%package pcmcia
Summary:	PCMCIA modules
Summary(pl.UTF-8):	Moduły PCMCIA
Group:		Base/Kernel
Requires(postun):	%{name}-up = %{epoch}:%{version}-%{release}
Requires:	%{name}-up = %{epoch}:%{version}-%{release}
Conflicts:	pcmcia-cs < %{_pcmcia_cs_ver}
Conflicts:	pcmciautils < %{_pcmciautils_ver}
Autoreqprov:	no

%description pcmcia
PCMCIA modules.

%description pcmcia -l pl.UTF-8
Moduły PCMCIA.

%package libs
Summary:	Libraries for preparing bootable kernel on PowerPCs
Summary(pl.UTF-8):	Biblioteki do przygotowania bootowalnego jądra dla PowerPC
Group:		Base/Kernel
Requires:	%{name}-up = %{epoch}:%{version}-%{release}
Requires:	mkvmlinuz >= %{_mkvmlinuz_ver}
Autoreqprov:	no

%description libs
Libraries for preparing bootable kernel on PowerPCs. Script called
mkvmlinuz may be useful for this.

%description libs -l pl.UTF-8
Biblioteki do przygotowania bootowalnego jądra dla PowerPC. Skrypt
mkvmlinuz może być do tego przydatny.

%package sound-alsa
Summary:	ALSA kernel modules
Summary(pl.UTF-8):	Sterowniki dźwięku ALSA
Group:		Base/Kernel
Requires(postun):	%{name}-up = %{epoch}:%{version}-%{release}
Requires:	%{name}-up = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description sound-alsa
ALSA (Advanced Linux Sound Architecture) sound drivers.

%description sound-alsa -l pl.UTF-8
Sterowniki dźwięku ALSA (Advanced Linux Sound Architecture).

%package sound-oss
Summary:	OSS kernel modules
Summary(pl.UTF-8):	Sterowniki dźwięku OSS
Group:		Base/Kernel
Requires(postun):	%{name}-up = %{epoch}:%{version}-%{release}
Requires:	%{name}-up = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description sound-oss
OSS (Open Sound System) drivers.

%description sound-oss -l pl.UTF-8
Sterowniki dźwięku OSS (Open Sound System).

%package smp
Summary:	Kernel version %{version} compiled for SMP machines
Summary(de.UTF-8):	Kernel version %{version} für Multiprozessor-Maschinen
Summary(fr.UTF-8):	Kernel version %{version} compiler pour les machine Multi-Processeur
Summary(pl.UTF-8):	Jądro Linuksa w wersji %{version} dla maszyn wieloprocesorowych
Group:		Base/Kernel
Requires(post):	coreutils
Requires(post):	geninitrd >= 2.57
Requires(post):	module-init-tools >= 0.9.9
Requires:	/sbin/depmod
Requires:	coreutils
Requires:	geninitrd >= 2.26
Requires:	module-init-tools >= 0.9.9
Provides:	%{name}(netfilter) = %{netfilter_snap}
Provides:	%{name}-smp(vermagic) = %{kernel_release}
%if %{with xen0}
Requires:	xen-hypervisor-abi = %{xen_hv_abi}
%endif
Obsoletes:	kernel-smp-misc-fuse
Obsoletes:	kernel-smp-net-hostap
Obsoletes:	kernel-smp-net-ieee80211
Obsoletes:	kernel-smp-net-ipp2p
Conflicts:	e2fsprogs < %{_e2fsprogs_ver}
Conflicts:	isdn4k-utils < %{_isdn4k_utils_ver}
Conflicts:	jfsutils < %{_jfsutils_ver}
Conflicts:	module-init-tool < %{_module_init_tool_ver}
Conflicts:	nfs-utils < %{_nfs_utils_ver}
Conflicts:	oprofile < %{_oprofile_ver}
Conflicts:	ppp < %{_ppp_ver}
Conflicts:	procps < %{_procps_ver}
Conflicts:	quota-tools < %{_quota_tools_ver}
%if %{with reiserfs4}
Conflicts:	reiser4progs < %{_reiser4progs_ver}
%endif
Conflicts:	reiserfsprogs < %{_reiserfsprogs_ver}
Conflicts:	util-linux < %{_util_linux_ver}
Conflicts:	xfsprogs < %{_xfsprogs_ver}
Autoreqprov:	no

%description smp
This package includes a SMP version of the Linux %{version} kernel. It
is required only on machines with two or more CPUs, although it should
work fine on single-CPU boxes.

Netfilter module dated: %{netfilter_snap}
%{?with_grsec_full:Grsecurity full support - enabled}
%{?with_pax:PaX support - enabled}
%{?with_xen0:Xen 0 - enabled}
%{?with_xenU:Xen U - enabled}
%{?with_vesafb_tng:VesaFB New generation - enabled}
%{?with_nfsroot:Root on NFS - enabled}

%description smp -l de.UTF-8
Dieses Paket enthält eine SMP (Multiprozessor)-Version von
Linux-Kernel %{version}. Es wird für Maschinen mit zwei oder mehr
Prozessoren gebraucht, sollte aber auch auf Computern mit nur einer
CPU laufen.

Netfilter module dated: %{netfilter_snap}
%{?with_grsec_full:Grsecurity full support - enabled}
%{?with_pax:PaX support - enabled}
%{?with_xen0:Xen 0 - enabled}
%{?with_xenU:Xen U - enabled}
%{?with_vesafb_tng:VesaFB New generation - enabled}
%{?with_nfsroot:Root on NFS - enabled}
%{?with_abi:Linux ABI support - enabled}

%description smp -l fr.UTF-8
Ce package inclu une version SMP du noyau de Linux version {version}.
Il et nécessaire seulement pour les machine avec deux processeurs ou
plus, il peut quand même fonctionner pour les système mono-processeur.

Netfilter module dated: %{netfilter_snap}
%{?with_grsec_full:Grsecurity full support - enabled}
%{?with_pax:PaX support - enabled}
%{?with_xen0:Xen 0 - enabled}
%{?with_xenU:Xen U - enabled}
%{?with_vesafb_tng:VesaFB New generation - enabled}
%{?with_nfsroot:Root on NFS - enabled}
%{?with_abi:Linux ABI support - enabled}

%description smp -l pl.UTF-8
Pakiet zawiera jądro SMP Linuksa w wersji %{version}. Jest ono
wymagane przez komputery zawierające dwa lub więcej procesorów.
Powinno również dobrze działać na maszynach z jednym procesorem.

Netfilter module dated: %{netfilter_snap}
%{?with_grsec_full:Grsecurity full support - enabled}
%{?with_pax:PaX support - enabled}
%{?with_xen0:Xen 0 - enabled}
%{?with_xenU:Xen U - enabled}
%{?with_vesafb_tng:VesaFB New generation - enabled}
%{?with_nfsroot:Root on NFS - enabled}
%{?with_abi:Linux ABI support - enabled}

%package smp-vmlinux
Summary:	vmlinux - uncompressed SMP kernel image
Summary(pl.UTF-8):	vmlinux - rozpakowany obraz jądra SMP
Group:		Base/Kernel

%description smp-vmlinux
vmlinux - uncompressed SMP kernel image.

%description smp-vmlinux -l pl.UTF-8
vmlinux - rozpakowany obraz jądra SMP.

%package smp-drm
Summary:	DRM SMP kernel modules
Summary(pl.UTF-8):	Sterowniki DRM dla maszyn wieloprocesorowych
Group:		Base/Kernel
Requires(postun):	%{name}-smp = %{epoch}:%{version}-%{release}
Requires:	%{name}-smp = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description smp-drm
DRM SMP kernel modules.

%description smp-drm -l pl.UTF-8
Sterowniki DRM dla maszyn wieloprocesorowych.

%package smp-pcmcia
Summary:	PCMCIA modules for SMP kernel
Summary(pl.UTF-8):	Moduły PCMCIA dla maszyn SMP
Group:		Base/Kernel
Requires(postun):	%{name}-smp = %{epoch}:%{version}-%{release}
Requires:	%{name}-smp = %{epoch}:%{version}-%{release}
Conflicts:	pcmcia-cs < %{_pcmcia_cs_ver}
Conflicts:	pcmciautils < %{_pcmciautils_ver}
Autoreqprov:	no

%description smp-pcmcia
PCMCIA modules for SMP kernel.

%description smp-pcmcia -l pl.UTF-8
Moduły PCMCIA dla maszyn SMP.

%package smp-libs
Summary:	Libraries for preparing bootable SMP kernel on PowerPCs
Summary(pl.UTF-8):	Biblioteki do przygotowania bootowalnego jądra dla wieloprocesorowych PowerPC
Group:		Base/Kernel
Requires:	%{name}-smp = %{epoch}:%{version}-%{release}
Requires:	mkvmlinuz >= %{_mkvmlinuz_ver}
Autoreqprov:	no

%description smp-libs
Libraries for preparing bootable SMP kernel on PowerPCs. Script called
mkvmlinuz may be useful for this.

%description smp-libs -l pl.UTF-8
Biblioteki do przygotowania bootowalnego jądra dla wieloprocesorowych
PowerPC. Skrypt mkvmlinuz może być do tego przydatny.

%package smp-sound-alsa
Summary:	ALSA SMP kernel modules
Summary(pl.UTF-8):	Sterowniki dźwięku ALSA dla maszyn wieloprocesorowych
Group:		Base/Kernel
Requires(postun):	%{name}-smp = %{epoch}:%{version}-%{release}
Requires:	%{name}-smp = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description smp-sound-alsa
ALSA (Advanced Linux Sound Architecture) SMP sound drivers.

%description smp-sound-alsa -l pl.UTF-8
Sterowniki dźwięku ALSA (Advanced Linux Sound Architecture) dla maszyn
wieloprocesorowych.

%package smp-sound-oss
Summary:	OSS SMP kernel modules
Summary(pl.UTF-8):	Sterowniki dźwięku OSS dla maszyn wieloprocesorowych
Group:		Base/Kernel
Requires(postun):	%{name}-smp = %{epoch}:%{version}-%{release}
Requires:	%{name}-smp = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description smp-sound-oss
OSS (Open Sound System) SMP sound drivers.

%description smp-sound-oss -l pl.UTF-8
Sterowniki OSS (Open Sound System) dla maszyn wieloprocesorowych.

%package headers
Summary:	Header files for the Linux kernel
Summary(pl.UTF-8):	Pliki nagłówkowe jądra Linuksa
Group:		Development/Building
Provides:	%{name}-headers(netfilter) = %{netfilter_snap}
Autoreqprov:	no

%description headers
These are the C header files for the Linux kernel, which define
structures and constants that are needed when rebuilding the kernel or
building kernel modules.

%description headers -l pl.UTF-8
Pakiet zawiera pliki nagłówkowe jądra, niezbędne do rekompilacji jądra
oraz budowania modułów jądra.

%package module-build
Summary:	Development files for building kernel modules
Summary(pl.UTF-8):	Pliki służące do budowania modułów jądra
Group:		Development/Building
Requires:	%{name}-headers = %{epoch}:%{version}-%{release}
Conflicts:	rpmbuild(macros) < 1.321
Autoreqprov:	no

%description module-build
Development files from kernel source tree needed to build Linux kernel
modules from external packages.

%description module-build -l pl.UTF-8
Pliki ze drzewa źródeł jądra potrzebne do budowania modułów jądra
Linuksa z zewnętrznych pakietów.

%package source
Summary:	Kernel source tree
Summary(pl.UTF-8):	Kod źródłowy jądra Linuksa
Group:		Development/Building
Requires:	%{name}-module-build = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description source
This is the source code for the Linux kernel. You can build a custom
kernel that is better tuned to your particular hardware.

%description source -l de.UTF-8
Das Kernel-Source-Paket enthält den source code (C/Assembler-Code) des
Linux-Kernels. Die Source-Dateien werden gebraucht, um viele
C-Programme zu compilieren, da sie auf Konstanten zurückgreifen, die
im Kernel-Source definiert sind. Die Source-Dateien können auch
benutzt werden, um einen Kernel zu compilieren, der besser auf Ihre
Hardware ausgerichtet ist.

%description source -l fr.UTF-8
Le package pour le kernel-source contient le code source pour le noyau
linux. Ces sources sont nécessaires pour compiler la plupart des
programmes C, car il dépend de constantes définies dans le code
source. Les sources peuvent être aussi utilisée pour compiler un noyau
personnalisé pour avoir de meilleures performances sur des matériels
particuliers.

%description source -l pl.UTF-8
Pakiet zawiera kod źródłowy jądra systemu.

%package doc
Summary:	Kernel documentation
Summary(pl.UTF-8):	Dokumentacja do jądra Linuksa
Group:		Documentation
Autoreqprov:	no

%description doc
This is the documentation for the Linux kernel, as found in
/usr/src/linux/Documentation directory.

%description doc -l pl.UTF-8
Pakiet zawiera dokumentację do jądra Linuksa pochodzącą z katalogu
/usr/src/linux/Documentation.

%prep
%setup -q -n linux-%{_basever} -a10
%{__bzip2} -dc %{SOURCE3} | patch -p1 -s

%ifarch ppc
install %{SOURCE5} Makefile.ppclibs
%endif

%patch1 -p1

%patch72 -p0
for i in suspend2-%{suspend_version}-for-2.6.16.9/[0-9]*; do
patch -p1 -s < $i
done
rm -rf suspend2-%{suspend_version}-for-2.6.16.9

%patch70 -p1
%patch71 -p1

# reiserfs4
%if %{with reiserfs4}
%{__gzip} -dc %{SOURCE12} | %{__patch} -s -p1
%endif

%patch2 -p1

%patch8 -p1
%if %{with bootsplash}
%patch3 -p1
%else
%patch4 -p1
%endif

%ifarch %{ix86}
%{?with_vesafb_tng:%patch5 -p1}
%endif

%patch6 -p1

%patch7 -p1
%patch9 -p1

## netfilter
# submitted

# base
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1

## extra
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1
%patch38 -p1
%patch39 -p1

##
# end of netfilter

%if %{with abi}
%patch40 -p1
%endif

%patch49 -p1

%patch50 -p1

%patch51 -p1

%patch53 -p1

%patch54 -p1

%patch55 -p1
%patch56 -p1


%ifarch %{ix86} %{x8664} ia64
%patch57 -p1
%endif

%patch60 -p1

%patch80 -p1

%patch81 -p1
%patch82 -p1
%ifnarch sparc64
%patch83 -p1
%endif

%patch85 -p1
%patch86 -p1

%patch90 -p1
%patch91 -p1
%patch92 -p1

%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1

%if %{with xen}
%ifarch %{ix86} %{x8664} ia64
%patch120 -p1
%patch121 -p1
%patch122 -p1
%endif
%endif

%patch140 -p1

%ifarch ppc ppc64
%patch200 -p1
%endif
%ifarch %{x8664}
%patch201 -p1
%endif
%ifarch ppc ppc64 %{ix86} %{x8664}
%patch202 -p1
%endif

%patch250 -p1

%patch252 -p1
%patch256 -p1

%patch260 -p1

# security patches

%patch1200 -p1
%patch1201 -p1

%if %{with grsec_minimal}
%patch1000 -p1
%endif
%if %{with grsec_full}
%patch9999 -p1
%patch10000 -p1
%endif

%if %{with pax}
%patch9999 -p1
%patch10000 -p1
%endif

%if %{with grsecurity}
%patch1001 -p1
%endif

# Fix EXTRAVERSION in main Makefile
sed -i 's#EXTRAVERSION =.*#EXTRAVERSION = %{_postver}%{?alt_kernel:_%{alt_kernel}}#g' Makefile

# on sparc this line causes CONFIG_INPUT=m (instead of =y), thus breaking build
sed -i -e '/select INPUT/d' net/bluetooth/hidp/Kconfig

# cleanup backups after patching
find '(' -name '*~' -o -name '*.orig' -o -name '.gitignore' ')' -print0 | xargs -0 -r -l512 rm -f

%build
TuneUpConfigForIX86 () {
%ifarch %{ix86}
	pae=
	[ "$2" = "yes" ] && pae=yes
	%if %{with pae}
	pae=yes
	%endif
	%ifnarch i386
	sed -i 's:CONFIG_M386=y:# CONFIG_M386 is not set:' $1
	%endif
	%ifarch i486
	sed -i 's:# CONFIG_M486 is not set:CONFIG_M486=y:' $1
	%endif
	%ifarch i586
	sed -i 's:# CONFIG_M586 is not set:CONFIG_M586=y:' $1
	%endif
	%ifarch i686
	sed -i 's:# CONFIG_M686 is not set:CONFIG_M686=y:' $1
	%endif
	%ifarch pentium3
	sed -i 's:# CONFIG_MPENTIUMIII is not set:CONFIG_MPENTIUMIII=y:' $1
	%endif
	%ifarch pentium4
	sed -i 's:# CONFIG_MPENTIUM4 is not set:CONFIG_MPENTIUM4=y:' $1
	%endif
	%ifarch athlon
	sed -i 's:# CONFIG_MK7 is not set:CONFIG_MK7=y:' $1
	%endif
	%ifarch i686 athlon pentium3 pentium4
	if [ "$pae" = "yes" ]; then
		sed -i "s:CONFIG_HIGHMEM4G=y:# CONFIG_HIGHMEM4G is not set:" $1
		sed -i "s:# CONFIG_HIGHMEM64G is not set:CONFIG_HIGHMEM64G=y\nCONFIG_X86_PAE=y:" $1
	fi
	sed -i 's:CONFIG_MATH_EMULATION=y:# CONFIG_MATH_EMULATION is not set:' $1
	%endif
	return 0
%endif
}

BuildConfig() {
	%{?debug:set -x}
	# is this a special kernel we want to build?
	smp=
	[ "$1" = "smp" -o "$2" = "smp" ] && smp=yes
	if [ "$smp" = "yes" ]; then
		Config="%{_target_base_arch}-smp"
	else
		Config="%{_target_base_arch}"
	fi
	KernelVer=%{kernel_release}$1

	echo "Building config file [using $Config.conf] for KERNEL $1..."
	cat $RPM_SOURCE_DIR/kernel-$Config.config > arch/%{_target_base_arch}/defconfig

	TuneUpConfigForIX86 arch/%{_target_base_arch}/defconfig "$smp"

%ifarch ppc ppc64
	if [ "$smp" = "yes" ]; then
		install %{SOURCE31} arch/%{_target_base_arch}/defconfig
	else
		install %{SOURCE30} arch/%{_target_base_arch}/defconfig
	fi
%endif

%ifarch ppc64
	sed -i "s:# CONFIG_PPC64 is not set:CONFIG_PPC64=y:" arch/%{_target_base_arch}/defconfig
%endif

	# netfilter
	cat %{SOURCE40} >> arch/%{_target_base_arch}/defconfig
	# squashfs
	cat %{SOURCE41} >> arch/%{_target_base_arch}/defconfig
	# suspend2
	cat %{SOURCE42} >> arch/%{_target_base_arch}/defconfig
%ifarch ppc ppc64
	sed -i "s:CONFIG_SUSPEND2=y:# CONFIG_SUSPEND2 is not set:" arch/%{_target_base_arch}/defconfig
%endif
	# vserver
	cat %{SOURCE43} >> arch/%{_target_base_arch}/defconfig
	# vesafb-tng
	cat %{SOURCE44} >> arch/%{_target_base_arch}/defconfig

%if %{with grsecurity}
	%if %{with pax}
		cat %{SOURCE49} >> arch/%{_target_base_arch}/defconfig
	%else
		cat %{SOURCE45} >> arch/%{_target_base_arch}/defconfig
	%endif
%endif

	# IPSEC KLIPS
	cat %{SOURCE50} >> arch/%{_target_base_arch}/defconfig

%if %{with abi}
	cat %{SOURCE51} >> arch/%{_target_base_arch}/defconfig
%endif

%if %{with xen}
	sed -i "s:CONFIG_X86_PC=y:# CONFIG_X86_PC is not set:" arch/%{_target_base_arch}/defconfig
	sed -i "s:CONFIG_RIO=[ym]:# CONFIG_RIO is not set:" arch/%{_target_base_arch}/defconfig

	# framebuffer devices generally don't work with xen
	# and kernel will crash on boot if vesafb-tng is compiled in (even if off by default)
	sed -i "s:CONFIG_FB=y:# CONFIG_FB is not set:" arch/%{_target_base_arch}/defconfig

	cat %{SOURCE48} >> arch/%{_target_base_arch}/defconfig
%endif

%if %{with xen0}
	cat %{SOURCE46} >> arch/%{_target_base_arch}/defconfig
%endif

%if %{with xenU}
	cat %{SOURCE47} >> arch/%{_target_base_arch}/defconfig
%endif

	# fbsplash
	echo "CONFIG_FB_SPLASH=y" >> arch/%{_target_base_arch}/defconfig
	# bootsplash
	echo "CONFIG_BOOTSPLASH=y" >> arch/%{_target_base_arch}/defconfig

%if %{with nfsroot}
	sed -i "s:CONFIG_NFS_FS=m:CONFIG_NFS_FS=y:" arch/%{_target_base_arch}/defconfig
	echo "CONFIG_ROOT_NFS=y" >> arch/%{_target_base_arch}/defconfig
%endif

%if %{with ext2compiled}
	sed -i 's,CONFIG_EXT2_FS=m,CONFIG_EXT2_FS=y,' arch/%{_target_base_arch}/defconfig
%endif

%{?debug:sed -i "s:# CONFIG_DEBUG_SLAB is not set:CONFIG_DEBUG_SLAB=y:" arch/%{_target_base_arch}/defconfig}
%{?debug:sed -i "s:# CONFIG_DEBUG_PREEMPT is not set:CONFIG_DEBUG_PREEMPT=y:" arch/%{_target_base_arch}/defconfig}
%{?debug:sed -i "s:# CONFIG_RT_DEADLOCK_DETECT is not set:CONFIG_RT_DEADLOCK_DETECT=y:" arch/%{_target_base_arch}/defconfig}

	if [ "$smp" = "yes" ]; then
		sed -e 's:CONFIG_LOCALVERSION="":CONFIG_LOCALVERSION="smp":'	\
			-i arch/%{_target_base_arch}/defconfig
	fi

	ln -sf arch/%{_target_base_arch}/defconfig .config
	install -d $KERNEL_INSTALL_DIR%{_kernelsrcdir}/include/linux
	rm -f include/linux/autoconf.h
	%{__make} %CrossOpts include/linux/autoconf.h
	if [ "$smp" = "yes" ]; then
		install include/linux/autoconf.h \
			$KERNEL_INSTALL_DIR%{_kernelsrcdir}/include/linux/autoconf-smp.h
		install .config \
			$KERNEL_INSTALL_DIR%{_kernelsrcdir}/config-smp
	else
		install include/linux/autoconf.h \
			$KERNEL_INSTALL_DIR%{_kernelsrcdir}/include/linux/autoconf-up.h
		install .config \
			$KERNEL_INSTALL_DIR%{_kernelsrcdir}/config-up
	fi
}

BuildKernel() {
	%{?debug:set -x}
	echo "Building kernel${1:+ $1}..."
	%{__make} %CrossOpts mrproper \
		RCS_FIND_IGNORE='-name build-done -prune -o'
	ln -sf arch/%{_target_base_arch}/defconfig .config

%ifarch sparc
	sparc32 %{__make} clean \
		RCS_FIND_IGNORE='-name build-done -prune -o'
%else
	%{__make} %CrossOpts clean \
		RCS_FIND_IGNORE='-name build-done -prune -o'
%endif
	%{__make} %CrossOpts include/linux/version.h \
		%{?with_verbose:V=1}

# make does vmlinux, modules and bzImage at once
%ifarch sparc sparc64
%ifarch sparc64
	%{__make} %CrossOpts image \
		%{?with_verbose:V=1}

	%{__make} %CrossOpts modules \
		%{?with_verbose:V=1}
%else
	sparc32 %{__make} \
		%{?with_verbose:V=1}
%endif
%else
	%{__make} %CrossOpts \
%if %{with xen}
		SHELL=/bin/bash \
%endif
		%{?with_verbose:V=1}
%endif
}

PreInstallKernel() {
	smp=
	[ "$1" = "smp" -o "$2" = "smp" ] && smp=yes
	if [ "$smp" = "yes" ]; then
		Config="%{_target_base_arch}-smp"
	else
		Config="%{_target_base_arch}"
	fi
	KernelVer=%{kernel_release}$1

	mkdir -p $KERNEL_INSTALL_DIR/boot
	install System.map $KERNEL_INSTALL_DIR/boot/System.map-$KernelVer
%ifarch %{ix86} %{x8664}
%if %{with xen}
	install vmlinuz $KERNEL_INSTALL_DIR/boot/vmlinuz-$KernelVer
%else
	install arch/%{_target_base_arch}/boot/bzImage $KERNEL_INSTALL_DIR/boot/vmlinuz-$KernelVer
%endif
	install vmlinux $KERNEL_INSTALL_DIR/boot/vmlinux-$KernelVer
%endif
%ifarch alpha sparc sparc64
	gzip -cfv vmlinux > vmlinuz
	install vmlinux $KERNEL_INSTALL_DIR/boot/vmlinux-$KernelVer
	install vmlinuz $KERNEL_INSTALL_DIR/boot/vmlinuz-$KernelVer
%ifarch sparc
	elftoaout arch/sparc/boot/image -o vmlinux.aout
	install vmlinux.aout $KERNEL_INSTALL_DIR/boot/vmlinux.aout-$KernelVer
%endif
%ifarch sparc64
	elftoaout arch/sparc64/boot/image -o vmlinux.aout
	install vmlinux.aout $KERNEL_INSTALL_DIR/boot/vmlinux.aout-$KernelVer
%endif
%endif
%ifarch ppc ppc64
	install vmlinux $KERNEL_INSTALL_DIR/boot/vmlinux-$KernelVer
	install vmlinux $KERNEL_INSTALL_DIR/boot/vmlinuz-$KernelVer
%endif
%ifarch ppc-broken
	%{__make} -f Makefile.ppclibs install \
		DESTDIR=$KERNEL_INSTALL_DIR/boot/libs-$KernelVer
%endif
%ifarch ia64
	gzip -cfv vmlinux > vmlinuz
	install -d $KERNEL_INSTALL_DIR/boot/efi
	install vmlinuz $KERNEL_INSTALL_DIR/boot/efi/vmlinuz-$KernelVer
	ln -sf efi/vmlinuz-$KernelVer $KERNEL_INSTALL_DIR/boot/vmlinuz-$KernelVer
%endif
	%{__make} %CrossOpts modules_install \
		%{?with_verbose:V=1} \
		DEPMOD=%DepMod \
		INSTALL_MOD_PATH=$KERNEL_INSTALL_DIR \
		KERNELRELEASE=$KernelVer

	if [ "$smp" = "yes" ]; then
		install Module.symvers \
			$KERNEL_INSTALL_DIR%{_kernelsrcdir}/Module.symvers-smp
	else
		install Module.symvers \
			$KERNEL_INSTALL_DIR%{_kernelsrcdir}/Module.symvers-up
	fi

	echo "CHECKING DEPENDENCIES FOR KERNEL MODULES"
	if [ %DepMod = /sbin/depmod ]; then
		/sbin/depmod --basedir $KERNEL_INSTALL_DIR -ae -F $KERNEL_INSTALL_DIR/boot/System.map-$KernelVer -r $KernelVer || :
	else
		touch $KERNEL_INSTALL_DIR/lib/modules/$KernelVer/modules.dep
	fi
	echo "KERNEL RELEASE $KernelVer DONE"
}

KERNEL_BUILD_DIR=`pwd`
echo "-%{_localversion}" > localversion

#install -m 644 %{SOURCE50} FAQ-pl

# UP KERNEL
KERNEL_INSTALL_DIR="$KERNEL_BUILD_DIR/build-done/kernel-UP"
rm -rf $KERNEL_INSTALL_DIR
BuildConfig
%if %{with up}
BuildKernel
PreInstallKernel
%endif

# SMP KERNEL
KERNEL_INSTALL_DIR="$KERNEL_BUILD_DIR/build-done/kernel-SMP"
rm -rf $KERNEL_INSTALL_DIR
BuildConfig smp
%if %{with smp}
BuildKernel smp
PreInstallKernel smp
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT

umask 022
# test if we can hardlink -- %{_builddir} and $RPM_BUILD_ROOT on same partition
if cp -al COPYING $RPM_BUILD_ROOT/COPYING 2>/dev/null; then
	l=l
	rm -f $RPM_BUILD_ROOT/COPYING
fi

export DEPMOD=%DepMod

install -d $RPM_BUILD_ROOT%{_kernelsrcdir}
install -d $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{kernel_release}{,smp}

KERNEL_BUILD_DIR=`pwd`

%if %{with up} || %{with smp}
cp -a$l $KERNEL_BUILD_DIR/build-done/kernel-*/* $RPM_BUILD_ROOT
%endif

for i in "" smp ; do
	if [ -e  $RPM_BUILD_ROOT/lib/modules/%{kernel_release}$i ] ; then
		rm -f $RPM_BUILD_ROOT/lib/modules/%{kernel_release}$i/build
		ln -sf %{_kernelsrcdir} \
			$RPM_BUILD_ROOT/lib/modules/%{kernel_release}$i/build
		install -d $RPM_BUILD_ROOT/lib/modules/%{kernel_release}$i/{cluster,misc}
	fi
done

find . -maxdepth 1 ! -name "build-done" ! -name "." -exec cp -a$l "{}" "$RPM_BUILD_ROOT%{_kernelsrcdir}/" ";"

cd $RPM_BUILD_ROOT%{_kernelsrcdir}

%{__make} %CrossOpts mrproper \
	RCS_FIND_IGNORE='-name build-done -prune -o'

if [ -e $KERNEL_BUILD_DIR/build-done/kernel-UP%{_kernelsrcdir}/include/linux/autoconf-up.h ]; then
install $KERNEL_BUILD_DIR/build-done/kernel-UP%{_kernelsrcdir}/include/linux/autoconf-up.h \
	$RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux
install	$KERNEL_BUILD_DIR/build-done/kernel-UP%{_kernelsrcdir}/config-up \
	$RPM_BUILD_ROOT%{_kernelsrcdir}
fi

if [ -e $KERNEL_BUILD_DIR/build-done/kernel-SMP%{_kernelsrcdir}/include/linux/autoconf-smp.h ]; then
install $KERNEL_BUILD_DIR/build-done/kernel-SMP%{_kernelsrcdir}/include/linux/autoconf-smp.h \
	$RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux
install	$KERNEL_BUILD_DIR/build-done/kernel-SMP%{_kernelsrcdir}/config-smp \
	$RPM_BUILD_ROOT%{_kernelsrcdir}
fi

%if %{with up} || %{with smp}
# UP or SMP
install $KERNEL_BUILD_DIR/build-done/kernel-*%{_kernelsrcdir}/include/linux/* \
	$RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux
%endif

%{__make} %CrossOpts mrproper
%{__make} %CrossOpts include/linux/version.h
install %{SOURCE1} $RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux/autoconf.h
install %{SOURCE2} $RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux/config.h

# collect module-build files and directories
perl %{SOURCE7} %{_kernelsrcdir} $KERNEL_BUILD_DIR

%if %{with up} || %{with smp}
# ghosted initrd
touch $RPM_BUILD_ROOT/boot/initrd-%{kernel_release}{,smp}.gz
install -d $RPM_BUILD_ROOT/lib/modules/%{kernel_release}{,smp}
rm -f $RPM_BUILD_ROOT/lib/modules/%{kernel_release}{,smp}/{build,source}
touch $RPM_BUILD_ROOT/lib/modules/%{kernel_release}{,smp}/{build,source}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%preun
if [ -x /sbin/new-kernel-pkg ]; then
	/sbin/new-kernel-pkg --remove %{kernel_release}
fi

%post
# - update /boot/vmlinuz
# - update /boot/vmlinuz-%{alt_kernel}
mv -f %{initrd_dir}/vmlinuz{,.old} 2> /dev/null
%{?alt_kernel:mv -f %{initrd_dir}/vmlinuz-%{alt_kernel}{,.old} 2> /dev/null}
mv -f %{initrd_dir}/System.map{,.old}  2> /dev/null
%{?alt_kernel:mv -f %{initrd_dir}/System-%{alt_kernel}.map{,.old} 2> /dev/null}

ln -sf vmlinuz-%{kernel_release} %{initrd_dir}/vmlinuz
%{?alt_kernel:ln -sf vmlinuz-%{kernel_release} %{initrd_dir}/vmlinuz-%{alt_kernel}}
ln -sf System.map-%{kernel_release} %{initrd_dir}/System.map
%{?alt_kernel:ln -sf System.map-%{kernel_release} %{initrd_dir}/System.map-%{alt_kernel}}

%depmod %{kernel_release}

%if %{without xenU}
/sbin/geninitrd -f --initrdfs=rom %{initrd_dir}/initrd-%{kernel_release}.gz %{kernel_release}

mv -f %{initrd_dir}/initrd{,.old} 2> /dev/null}
%{?alt_kernel:mv -f %{initrd_dir}/initrd-%{alt_kernel}{,.old} 2> /dev/null}
ln -sf initrd-%{kernel_release}.gz %{initrd_dir}/initrd
%{?alt_kernel:ln -sf initrd-%{kernel_release}.gz %{initrd_dir}/initrd-%{alt_kernel}}

if [ -x /sbin/new-kernel-pkg ]; then
%if %{with xen0}
	xenimg=%{initrd_dir}/xen.gz
	xenver=
	xen=$(readlink -f $xenimg)
	if [ "$xen" != "$xenimg" ]; then
		xenver=${xen#%{initrd_dir}/xen-}
		xenver=${xenver%.gz}
	fi

	title="Xen${xenver:+ $xenver} / PLD Linux (%{pld_release})"
	args=--multiboot=$xen
%else
	title="PLD Linux (%{pld_release})%{?alt_kernel: / %{alt_kernel}}"
%endif

	/sbin/new-kernel-pkg $args --initrdfile=%{initrd_dir}/initrd-%{kernel_release}.gz --install %{kernel_release} --banner "$title"

elif [ -x /sbin/rc-boot ]; then
	/sbin/rc-boot 1>&2 || :
fi
%endif

%post vmlinux
mv -f %{initrd_dir}/vmlinux{,.old} 2> /dev/null
%{?alt_kernel:mv -f %{initrd_dir}/vmlinux-%{alt_kernel}{,.old} 2> /dev/null}
ln -sf vmlinux-%{kernel_release} %{initrd_dir}/vmlinux
%{?alt_kernel:ln -sf vmlinux-%{kernel_release} %{initrd_dir}/vmlinux-%{alt_kernel}}

%post libs
%{_sbindir}/mkvmlinuz %{initrd_dir}/zImage-%{version}-%{release} %{version}-%{release}

%post drm
%depmod %{kernel_release}

%postun drm
%depmod %{kernel_release}

%post pcmcia
%depmod %{kernel_release}

%postun pcmcia
%depmod %{kernel_release}

%post sound-alsa
%depmod %{kernel_release}

%postun sound-alsa
%depmod %{kernel_release}

%post sound-oss
%depmod %{kernel_release}

%postun sound-oss
%depmod %{kernel_release}

%preun smp
if [ -x /sbin/new-kernel-pkg ]; then
	/sbin/new-kernel-pkg --remove %{kernel_release}smp
fi

%post smp
# - update /boot/vmlinuz
# - update /boot/vmlinuz-%{alt_kernel}
mv -f %{initrd_dir}/vmlinuz{,.old} 2> /dev/null
%{?alt_kernel:mv -f %{initrd_dir}/vmlinuz-%{alt_kernel}{,.old} 2> /dev/null}
mv -f %{initrd_dir}/System.map{,.old}  2> /dev/null
%{?alt_kernel:mv -f %{initrd_dir}/System-%{alt_kernel}.map{,.old} 2> /dev/null}

ln -sf vmlinuz-%{kernel_release}smp %{initrd_dir}/vmlinuz
%{?alt_kernel:ln -sf vmlinuz-%{kernel_release}smp %{initrd_dir}/vmlinuz-%{alt_kernel}}
ln -sf System.map-%{kernel_release}smp %{initrd_dir}/System.map
%{?alt_kernel:ln -sf System.map-%{kernel_release}smp %{initrd_dir}/System.map-%{alt_kernel}}

%depmod %{kernel_release}smp

%if %{without xenU}
/sbin/geninitrd -f --initrdfs=rom %{initrd_dir}/initrd-%{kernel_release}smp.gz %{kernel_release}smp

mv -f %{initrd_dir}/initrd{,.old} 2> /dev/null}
%{?alt_kernel:mv -f %{initrd_dir}/initrd-%{alt_kernel}{,.old} 2> /dev/null}
ln -sf initrd-%{kernel_release}smp.gz %{initrd_dir}/initrd
%{?alt_kernel:ln -sf initrd-%{kernel_release}smp.gz %{initrd_dir}/initrd-%{alt_kernel}}

if [ -x /sbin/new-kernel-pkg ]; then
%if %{with xen0}
	xenimg=%{initrd_dir}/xen.gz
	xenver=
	xen=$(readlink -f $xenimg)
	if [ "$xen" != "$xenimg" ]; then
		xenver=${xen#%{initrd_dir}/xen-}
		xenver=${xenver%.gz}
	fi

	title="Xen${xenver:+ $xenver} / PLD Linux (%{pld_release})"
	args=--multiboot=$xen
%else
	title="PLD Linux (%{pld_release})%{?alt_kernel: / %{alt_kernel}}"
%endif

	/sbin/new-kernel-pkg $args --initrdfile=%{initrd_dir}/initrd-%{kernel_release}smp.gz --install %{kernel_release}smp --banner "$title"

elif [ -x /sbin/rc-boot ]; then
	/sbin/rc-boot 1>&2 || :
fi
%endif

%post smp-vmlinux
mv -f /boot/vmlinux{,.old} 2> /dev/null
%{?alt_kernel:mv -f /boot/vmlinux-%{alt_kernel}{,.old} 2> /dev/null}
ln -sf vmlinux-%{kernel_release}smp /boot/vmlinux
%{?alt_kernel:ln -sf vmlinux-%{kernel_release}smp /boot/vmlinux-%{alt_kernel}}

%post smp-libs
%{_sbindir}/mkvmlinuz /boot/zImage-%{version}-%{release}smp %{version}-%{release}smp

%post smp-drm
%depmod %{kernel_release}smp

%postun smp-drm
%depmod %{kernel_release}smp

%post smp-pcmcia
%depmod %{kernel_release}smp

%postun smp-pcmcia
%depmod %{kernel_release}smp

%post smp-sound-alsa
%depmod %{kernel_release}smp

%postun smp-sound-alsa
%depmod %{kernel_release}smp

%post smp-sound-oss
%depmod %{kernel_release}smp

%postun smp-sound-oss
%depmod %{kernel_release}smp

%post headers
ln -snf %{basename:%{_kernelsrcdir}} %{_prefix}/src/linux%{_alt_kernel}

%postun headers
if [ "$1" = "0" ]; then
	if [ -L %{_prefix}/src/linux%{_alt_kernel} ]; then
		if [ "$(readlink %{_prefix}/src/linux%{_alt_kernel})" = "linux%{_alt_kernel}-%{version}" ]; then
			rm -f %{_prefix}/src/linux%{_alt_kernel}
		fi
	fi
fi

%triggerin module-build -- %{name} = %{epoch}:%{version}-%{release}
ln -sfn %{_kernelsrcdir} /lib/modules/%{kernel_release}/build
ln -sfn %{_kernelsrcdir} /lib/modules/%{kernel_release}/source

%triggerun module-build -- %{name} = %{epoch}:%{version}-%{release}
if [ "$1" = 0 ]; then
	rm -f /lib/modules/%{kernel_release}/{build,source}
fi

%triggerin module-build -- %{name}-smp = %{epoch}:%{version}-%{release}
ln -sfn %{_kernelsrcdir} /lib/modules/%{kernel_release}smp/build
ln -sfn %{_kernelsrcdir} /lib/modules/%{kernel_release}smp/source

%triggerun module-build -- %{name}-smp = %{epoch}:%{version}-%{release}
if [ "$1" = 0 ]; then
	rm -f /lib/modules/%{kernel_release}smp/{build,source}
fi

%if %{with up}
%files
%defattr(644,root,root,755)
#doc FAQ-pl
%ifarch sparc sparc64
/boot/vmlinux.aout-%{kernel_release}
%endif
%{initrd_dir}/vmlinuz-%{kernel_release}
%{initrd_dir}/System.map-%{kernel_release}
%ghost %{initrd_dir}/initrd-%{kernel_release}.gz
%dir /lib/modules/%{kernel_release}
%dir /lib/modules/%{kernel_release}/kernel
%ifnarch sparc
/lib/modules/%{kernel_release}/kernel/arch
%endif
/lib/modules/%{kernel_release}/kernel/crypto
/lib/modules/%{kernel_release}/kernel/drivers
%if %{have_drm}
%exclude /lib/modules/%{kernel_release}/kernel/drivers/char/drm
%endif
%if %{have_oss} && %{have_isa} && %{without xen}
%exclude /lib/modules/%{kernel_release}/kernel/drivers/media/radio/miropcm20.ko*
%endif
%if %{with abi}
/lib/modules/%{kernel_release}/kernel/abi
%endif
/lib/modules/%{kernel_release}/kernel/fs
/lib/modules/%{kernel_release}/kernel/kernel
/lib/modules/%{kernel_release}/kernel/lib
/lib/modules/%{kernel_release}/kernel/net
/lib/modules/%{kernel_release}/kernel/security
%if %{have_sound}
%dir /lib/modules/%{kernel_release}/kernel/sound
/lib/modules/%{kernel_release}/kernel/sound/soundcore.*
%endif
%dir /lib/modules/%{kernel_release}/misc
%if %{with pcmcia}
%exclude /lib/modules/%{kernel_release}/kernel/drivers/pcmcia
%exclude /lib/modules/%{kernel_release}/kernel/drivers/*/pcmcia
%exclude /lib/modules/%{kernel_release}/kernel/drivers/bluetooth/*_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/ide/legacy/ide-cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/isdn/hardware/avm/avm_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/net/wireless/*_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/net/wireless/hostap/hostap_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/parport/parport_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/serial/serial_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/telephony/ixj_pcmcia.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/usb/host/sl811_cs.ko*
%endif
%ghost /lib/modules/%{kernel_release}/modules.*
# symlinks pointing to kernelsrcdir
%ghost /lib/modules/%{kernel_release}/build
%ghost /lib/modules/%{kernel_release}/source
%dir %{_sysconfdir}/modprobe.d/%{kernel_release}

%ifarch alpha %{ix86} %{x8664} ppc ppc64 sparc sparc64
%files vmlinux
%defattr(644,root,root,755)
%{initrd_dir}/vmlinux-%{kernel_release}
%endif

%if %{have_drm}
%files drm
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}/kernel/drivers/char/drm
%endif

%if %{with pcmcia}
%files pcmcia
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}/kernel/drivers/pcmcia
/lib/modules/%{kernel_release}/kernel/drivers/*/pcmcia
/lib/modules/%{kernel_release}/kernel/drivers/bluetooth/*_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/ide/legacy/ide-cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/isdn/hardware/avm/avm_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/net/wireless/*_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/net/wireless/hostap/hostap_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/parport/parport_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/serial/serial_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/telephony/ixj_pcmcia.ko*
/lib/modules/%{kernel_release}/kernel/drivers/usb/host/sl811_cs.ko*
%endif

%ifarch ppc-broken
%if "%{_arch}" == "ppc"
%files libs
%defattr(644,root,root,755)
%dir %{initrd_dir}/libs-%{kernel_release}
%{initrd_dir}/libs-%{kernel_release}/common
%{initrd_dir}/libs-%{kernel_release}/kernel
%{initrd_dir}/libs-%{kernel_release}/lib
%{initrd_dir}/libs-%{kernel_release}/of1275
%{initrd_dir}/libs-%{kernel_release}/openfirmware
%{initrd_dir}/libs-%{kernel_release}/simple
%dir %{initrd_dir}/libs-%{kernel_release}/utils
%attr(755,root,root) %{initrd_dir}/libs-%{kernel_release}/utils/*
%{initrd_dir}/libs-%{kernel_release}/ld.script
%endif
%endif

%if %{have_sound}
%files sound-alsa
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}/kernel/sound
%exclude %dir /lib/modules/%{kernel_release}/kernel/sound
%exclude /lib/modules/%{kernel_release}/kernel/sound/soundcore.*
%if %{have_oss}
%exclude /lib/modules/%{kernel_release}/kernel/sound/oss
%endif

%if %{have_oss}
%files sound-oss
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}/kernel/sound/oss
%if %{have_isa} && %{without xen}
/lib/modules/%{kernel_release}/kernel/drivers/media/radio/miropcm20.ko*
%endif
%endif
%endif			# %%{have_sound}
%endif			# %%{with up}

%if %{with smp}
%files smp
%defattr(644,root,root,755)
#doc FAQ-pl
%{initrd_dir}/vmlinuz-%{kernel_release}smp
%{initrd_dir}/System.map-%{kernel_release}smp
%ghost %{initrd_dir}/initrd-%{kernel_release}smp.gz
%dir /lib/modules/%{kernel_release}smp
%dir /lib/modules/%{kernel_release}smp/kernel
%ifnarch sparc
/lib/modules/%{kernel_release}smp/kernel/arch
%endif
/lib/modules/%{kernel_release}smp/kernel/crypto
/lib/modules/%{kernel_release}smp/kernel/drivers
%if %{have_drm}
%exclude /lib/modules/%{kernel_release}smp/kernel/drivers/char/drm
%endif
%if %{have_oss} && %{have_isa} && %{without xen}
%exclude /lib/modules/%{kernel_release}smp/kernel/drivers/media/radio/miropcm20.ko*
%endif
%if %{with abi}
/lib/modules/%{kernel_release}smp/kernel/abi
%endif
/lib/modules/%{kernel_release}smp/kernel/fs
/lib/modules/%{kernel_release}smp/kernel/kernel
/lib/modules/%{kernel_release}smp/kernel/lib
/lib/modules/%{kernel_release}smp/kernel/net
/lib/modules/%{kernel_release}smp/kernel/security
%if %{have_sound}
%dir /lib/modules/%{kernel_release}smp/kernel/sound
/lib/modules/%{kernel_release}smp/kernel/sound/soundcore.*
%endif
%dir /lib/modules/%{kernel_release}smp/misc
%if %{with pcmcia}
%exclude /lib/modules/%{kernel_release}smp/kernel/drivers/pcmcia
%exclude /lib/modules/%{kernel_release}smp/kernel/drivers/*/pcmcia
%exclude /lib/modules/%{kernel_release}smp/kernel/drivers/bluetooth/*_cs.ko*
%exclude /lib/modules/%{kernel_release}smp/kernel/drivers/ide/legacy/ide-cs.ko*
%exclude /lib/modules/%{kernel_release}smp/kernel/drivers/isdn/hardware/avm/avm_cs.ko*
%exclude /lib/modules/%{kernel_release}smp/kernel/drivers/net/wireless/*_cs.ko*
%exclude /lib/modules/%{kernel_release}smp/kernel/drivers/net/wireless/hostap/hostap_cs.ko*
%exclude /lib/modules/%{kernel_release}smp/kernel/drivers/parport/parport_cs.ko*
%exclude /lib/modules/%{kernel_release}smp/kernel/drivers/serial/serial_cs.ko*
%exclude /lib/modules/%{kernel_release}smp/kernel/drivers/telephony/ixj_pcmcia.ko*
%exclude /lib/modules/%{kernel_release}smp/kernel/drivers/usb/host/sl811_cs.ko*
%endif
%ghost /lib/modules/%{kernel_release}smp/modules.*
# symlinks pointing to kernelsrcdir
%ghost /lib/modules/%{kernel_release}smp/build
%ghost /lib/modules/%{kernel_release}smp/source
%dir %{_sysconfdir}/modprobe.d/%{kernel_release}smp

%ifarch alpha %{ix86} %{x8664} ppc ppc64 sparc sparc64
%files smp-vmlinux
%defattr(644,root,root,755)
%{initrd_dir}/vmlinux-%{kernel_release}smp
%endif

%if %{have_drm}
%files smp-drm
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}smp/kernel/drivers/char/drm
%endif

%if %{with pcmcia}
%files smp-pcmcia
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}smp/kernel/drivers/pcmcia
/lib/modules/%{kernel_release}smp/kernel/drivers/*/pcmcia
/lib/modules/%{kernel_release}smp/kernel/drivers/bluetooth/*_cs.ko*
/lib/modules/%{kernel_release}smp/kernel/drivers/ide/legacy/ide-cs.ko*
/lib/modules/%{kernel_release}smp/kernel/drivers/isdn/hardware/avm/avm_cs.ko*
/lib/modules/%{kernel_release}smp/kernel/drivers/net/wireless/*_cs.ko*
/lib/modules/%{kernel_release}smp/kernel/drivers/net/wireless/hostap/hostap_cs.ko*
/lib/modules/%{kernel_release}smp/kernel/drivers/parport/parport_cs.ko*
/lib/modules/%{kernel_release}smp/kernel/drivers/serial/serial_cs.ko*
/lib/modules/%{kernel_release}smp/kernel/drivers/telephony/ixj_pcmcia.ko*
/lib/modules/%{kernel_release}smp/kernel/drivers/usb/host/sl811_cs.ko*
%endif

%ifarch ppc-broken
%if "%{_arch}" == "ppc"
%files smp-libs
%defattr(644,root,root,755)
%dir %{initrd_dir}/libs-%{kernel_release}smp
%{initrd_dir}/libs-%{kernel_release}smp/common
%{initrd_dir}/libs-%{kernel_release}smp/kernel
%{initrd_dir}/libs-%{kernel_release}smp/lib
%{initrd_dir}/libs-%{kernel_release}smp/of1275
%{initrd_dir}/libs-%{kernel_release}smp/openfirmware
%{initrd_dir}/libs-%{kernel_release}smp/simple
%dir %{initrd_dir}/libs-%{kernel_release}smp/utils
%attr(755,root,root) %{initrd_dir}/libs-%{kernel_release}smp/utils/*
%{initrd_dir}/libs-%{kernel_release}smp/ld.script
%endif
%endif

%if %{have_sound}
%files smp-sound-alsa
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}smp/kernel/sound
%exclude %dir /lib/modules/%{kernel_release}smp/kernel/sound
%exclude /lib/modules/%{kernel_release}smp/kernel/sound/soundcore.*
%if %{have_oss}
%exclude /lib/modules/%{kernel_release}smp/kernel/sound/oss
%endif

%if %{have_oss}
%files smp-sound-oss
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}smp/kernel/sound/oss
%if %{have_isa} && %{without xen}
/lib/modules/%{kernel_release}smp/kernel/drivers/media/radio/miropcm20.ko*
%endif
%endif
%endif			# %%{have_sound}
%endif			# %%{with smp}

%files headers
%defattr(644,root,root,755)
%dir %{_kernelsrcdir}
%{_kernelsrcdir}/include
%if %{with smp}
%{_kernelsrcdir}/config-smp
%{_kernelsrcdir}/Module.symvers-smp
%endif
%{_kernelsrcdir}/config-up
%{?with_up:%{_kernelsrcdir}/Module.symvers-up}

%files module-build -f aux_files
%defattr(644,root,root,755)
%{_kernelsrcdir}/Kbuild
%{_kernelsrcdir}/localversion
%{_kernelsrcdir}/arch/*/kernel/asm-offsets.*
%{_kernelsrcdir}/arch/*/kernel/sigframe.h
%dir %{_kernelsrcdir}/scripts
%dir %{_kernelsrcdir}/scripts/kconfig
%{_kernelsrcdir}/scripts/Kbuild.include
%{_kernelsrcdir}/scripts/Makefile*
%{_kernelsrcdir}/scripts/basic
%{_kernelsrcdir}/scripts/mkmakefile
%{_kernelsrcdir}/scripts/mod
%{_kernelsrcdir}/scripts/setlocalversion
%{_kernelsrcdir}/scripts/*.c
%{_kernelsrcdir}/scripts/*.sh
%{_kernelsrcdir}/scripts/kconfig/*

%files doc
%defattr(644,root,root,755)
%{_kernelsrcdir}/Documentation

%if %{with source}
%files source -f aux_files_exc
%defattr(644,root,root,755)
%{_kernelsrcdir}/arch/*/[!Mk]*
%{_kernelsrcdir}/arch/*/kernel/[!M]*
%exclude %{_kernelsrcdir}/arch/*/kernel/asm-offsets.*
%exclude %{_kernelsrcdir}/arch/*/kernel/sigframe.h
%if %{with abi}
%{_kernelsrcdir}/abi
%endif /* abi */
%{_kernelsrcdir}/block
%{_kernelsrcdir}/crypto
%{_kernelsrcdir}/drivers
%{_kernelsrcdir}/fs
%if %{with grsecurity}
%{_kernelsrcdir}/grsecurity
%endif
%{_kernelsrcdir}/init
%{_kernelsrcdir}/ipc
%{_kernelsrcdir}/kernel
%{_kernelsrcdir}/lib
%{_kernelsrcdir}/mm
%{_kernelsrcdir}/net
%{_kernelsrcdir}/scripts/*
%exclude %{_kernelsrcdir}/scripts/Kbuild.include
%exclude %{_kernelsrcdir}/scripts/Makefile*
%exclude %{_kernelsrcdir}/scripts/basic
%exclude %{_kernelsrcdir}/scripts/kconfig
%exclude %{_kernelsrcdir}/scripts/mkmakefile
%exclude %{_kernelsrcdir}/scripts/mod
%exclude %{_kernelsrcdir}/scripts/setlocalversion
%exclude %{_kernelsrcdir}/scripts/*.c
%exclude %{_kernelsrcdir}/scripts/*.sh
%{_kernelsrcdir}/sound
%{_kernelsrcdir}/security
%{_kernelsrcdir}/usr
%{_kernelsrcdir}/COPYING
%{_kernelsrcdir}/CREDITS
%{_kernelsrcdir}/MAINTAINERS
%{_kernelsrcdir}/README
%{_kernelsrcdir}/REPORTING-BUGS
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: kernel.spec,v $
Revision 1.441.2.1558.2.164  2009/08/18 02:09:41  adamg
- cherrypicked ac5a488e commit from linux-2.6.git; release 3

Revision 1.441.2.1558.2.163  2009/08/17 12:11:44  adamg
- fix for CVE-2009-2692
- release 2

Revision 1.441.2.1558.2.162  2008/11/03 08:43:07  marcus
- cciss updated
- nforce updated

Revision 1.441.2.1558.2.161  2008/08/12 19:42:16  glen
- ne more CVE entry for 2.6.16.62

Revision 1.441.2.1558.2.160  2008/07/21 23:07:28  adamg
- updated to 2.6.16.62 (CVE-2008-0598, CVE-2008-2826)
- CVE entry for 2.6.16.61

Revision 1.441.2.1558.2.159  2008/07/21 10:54:10  adamg
- xen0/xenU todo entry (compile failure)

Revision 1.441.2.1558.2.158  2008/07/18 14:43:34  adamg
- updated to 2.6.16.61 [CVE-2008-1669]

Revision 1.441.2.1558.2.157  2008/07/02 15:25:10  glen
- revert

Revision 1.441.2.1558.2.156  2008/06/18 15:33:13  adamg
- Provides: kernel(xen0)

Revision 1.441.2.1558.2.155  2008-05-24 12:04:55  glen
- add pae to kernel_release (except xen* to avoid xen0pae in name)
- update xen related initrd generation, add xen-hypervisor-abi virtual; rel 15

Revision 1.441.2.1558.2.154  2008-05-23 19:35:44  glen
- pae is %{ix86} above (including) i686 only
- add -pae as alt kernel
- add xen bcond if any of the xen0/xenU is set

Revision 1.441.2.1558.2.153  2008-05-07 14:11:24  glen
- use %{initrd_dir} macro, possibly fixing ia64 efi
-  fix /boot symlinks for alt_kernel; rel 14

Revision 1.441.2.1558.2.152  2008-05-06 12:21:59  glen
- kernel-xen0-smp also Requires xen userspace

Revision 1.441.2.1558.2.151  2008-04-27 18:23:54  glen
- xen patch to allow building nvidia module
- update symlinks handling, always /boot/vmlinuz points to last installed kernel, same for alt kernel
- simplify by using alt_kernel instead of dashxen, xen macros

Revision 1.441.2.1558.2.150  2008-04-27 10:48:48  glen
- multiboot grubby install for xen0; rel 12

Revision 1.441.2.1558.2.149  2008-04-08 08:01:51  glen
- kabi 6 for main kernel, grsec has 9 (sic)

Revision 1.441.2.1558.2.148  2008-04-07 08:53:05  glen
- kabi back to 9, modules need not to be rebuild with last update

Revision 1.441.2.1558.2.147  2008-04-06 16:20:16  marcus
- rel.10. KABI 10. Fixed charset in descriptions.

Revision 1.441.2.1558.2.146  2008-04-06 14:09:21  marcus
- addedd ICH9 and new 3w-9xxx and SIP conntrack module

Revision 1.441.2.1558.2.145  2008-02-26 10:03:42  marcus
- added %files for abi

Revision 1.441.2.1558.2.144  2008-02-26 09:47:23  marcus
- addedd Linux-ABI support. Bcond, default disabled.

Revision 1.441.2.1558.2.143  2008-02-18 15:37:08  glen
- fix for "-" vs "_" in grsec kernel; rel 9

Revision 1.441.2.1558.2.142  2008-02-15 19:47:25  glen
- fix expression parsing

Revision 1.441.2.1558.2.141  2008-02-15 19:16:25  glen
- hehe, define alt_kernel only if it would be not empty

Revision 1.441.2.1558.2.140  2008-02-15 16:35:21  glen
- unify: add alt kernel (subname) with underscore; rel 7

Revision 1.441.2.1558.2.139  2008-02-14 08:25:40  undefine
- fix build sparc64 on sparc arch. binutils are _native_ not, cross-

Revision 1.441.2.1558.2.138  2008-02-13 22:46:00  glen
- better English

Revision 1.441.2.1558.2.137  2008-02-13 19:44:29  glen
- release 6

Revision 1.441.2.1558.2.136  2008-02-13 18:29:34  undefine
- fix when only smp or only up are built

Revision 1.441.2.1558.2.135  2008-02-13 17:03:45  glen
- fix {build,source} symlinks
- added %{subname} to kernel_release to allow simultaneous installation
  of normal and grsecurity kernel (there was conflict on
  /lib/modules/%{version}-%{release})
- provide %{name}(vermagic) for module deps
- rel 5

Revision 1.441.2.1558.2.134  2008-02-13 09:42:33  glen
- move build and source symlinks to main pkg and use triggers to make links (fixes grsec and plain module-build collision)

Revision 1.441.2.1558.2.133  2008-02-12 08:34:38  glen
- release 4

Revision 1.441.2.1558.2.132  2008-02-12 08:29:55  glen
- R: /sbin/depmod, instead of conflicting on vserver-packages

Revision 1.441.2.1558.2.131  2008-02-11 19:15:39  zbyniu
- kernel-CVE-2008-0163.patch added, rel 3

Revision 1.441.2.1558.2.130  2008-02-08 09:30:53  marcus
- updated tg3 driver to version 3.81c from Broadcom

Revision 1.441.2.1558.2.129  2008-01-27 23:43:54  glen
- 2.6.16.60
  CVE-2007-6206, CVE-2007-6151, CVE-2007-6063

Revision 1.441.2.1558.2.128  2008-01-19 17:20:03  glen
- use %{name} macro

Revision 1.441.2.1558.2.127  2008-01-19 17:11:28  glen
- description merge from LINUX_2_6_22

Revision 1.441.2.1558.2.126  2008-01-19 17:09:01  glen
- summary merge from LINUX_2_6_22

Revision 1.441.2.1558.2.125  2008-01-19 16:40:59  glen
- netfilter provide with alt kernel support

Revision 1.441.2.1558.2.124  2008-01-19 16:32:46  glen
- no manual removal needed, %ghost does that

Revision 1.441.2.1558.2.123  2008-01-19 16:32:02  glen
- drop dozen of provides, leave only internal deps
- besides by pld policy shouldn't depend on kernel package(s)
- drop unused/pointless macros
- only netfilter deps left due iptables.spec

Revision 1.441.2.1558.2.122  2008-01-19 13:53:45  glen
- 2.6.16.59
  CVE-2008-0001, CVE-2006-6058

Revision 1.441.2.1558.2.121  2008-01-19 12:50:25  glen
- undo charset fuckup (again)

Revision 1.441.2.1558.2.120  2008-01-18 23:07:18  marcus
- apply asm/segment.h patch from OpenWRT

Revision 1.441.2.1558.2.119  2008-01-18 14:14:31  marcus
- KLIPS is back. wrrr. On what archs it doesn; build ?
  Tested on i686 and amd64. Please send to test build.
  Rel.2.

Revision 1.441.2.1558.2.118  2008-01-17 23:42:37  glen
- no pain provides for kernel-headers

Revision 1.441.2.1558.2.117  2008-01-17 23:40:31  glen
- 2.6.16.58
  CVE-2007-2525, CVE-2007-6417

Revision 1.441.2.1558.2.116  2007-11-28 00:16:32  glen
- revert ipsec KLIPS for compatibility with ipsec changes from r1.441.2.1558.2.109
  they are broken in way that not all AC archidectures build. make sure
  kernel.spec still builds on all archidectures if you want these patches added.

Revision 1.441.2.1558.2.115  2007-11-22 15:07:59  adamg
- exclude i{3,4,5}86 when building xen kernels

Revision 1.441.2.1558.2.114  2007-11-13 07:29:16  marcus
- wrrrrrrrr ;)

Revision 1.441.2.1558.2.112  2007-11-13 07:16:36  glen
- converted to utf8

Revision 1.441.2.1558.2.111  2007-11-13 07:12:49  glen
- revert charset corruption

Revision 1.441.2.1558.2.110  2007-11-13 07:10:34  marcus
- rel.2.

Revision 1.441.2.1558.2.109  2007-11-13 06:47:35  marcus
- addedd ipsec KLIPS for compatibility with ipsec from kernel24

Revision 1.441.2.1558.2.108  2007-11-06 08:19:58  glen
- 2.6.16.57

Revision 1.441.2.1558.2.107  2007/11/06 01:49:28  glen
- add -TIOCGDEV.patch, adapter

Revision 1.441.2.1558.2.106  2007/11/04 09:15:01  adamg
- backported security patches from 2.6.16.57-rc1 (resolves
  CVE-2007-3740, CVE-2007-4308, CVE-2007-4997, CVE-2007-5093)
- release 2

Revision 1.441.2.1558.2.105  2007/11/01 07:44:54  adamg
- updated to 2.6.16.56 (CVE-2007-3799, CVE-2007-4133)

Revision 1.441.2.1558.2.104  2007/10/30 18:01:45  glen
- vserver todo

Revision 1.441.2.1558.2.103  2007/10/15 08:25:03  glen
- CVE-2007-4573 patch is upstream

Revision 1.441.2.1558.2.102  2007/10/14 21:53:37  adamg
- updated to 2.6.16.55 (CVE-2007-4571, CVE-2007-3104, CVE-2007-3105,
  CVE-2007-2453, CVE-2007-3848, CVE-2005-0504, CVE-2007-4573)

Revision 1.441.2.1558.2.101  2007/10/14 14:45:22  glen
- 2.6.16.54

Revision 1.441.2.1558.2.100  2007/09/27 20:49:02  arekm
- rel 2; fix for local root hole CVE-2007-4573

Revision 1.441.2.1558.2.99  2007/08/18 09:59:16  glen
- -source is not needed to compile C programs

Revision 1.441.2.1558.2.98  2007/07/26 08:03:44  adamg
- CVE entry for 2.6.16.53

Revision 1.441.2.1558.2.97  2007/07/25 22:25:25  adamg
- updated to 2.6.16.53 (resolves CVE-2007-2876)

Revision 1.441.2.1558.2.96  2007/07/14 19:38:41  adamg
- linux-2.6-grsec-wrong-deref.patch patch applied - should fix rare oopses
  noticed on some machines; thx qboosh
- release 2

Revision 1.441.2.1558.2.95  2007/06/24 10:15:11  marcus
- added pci-id for nforce4 audio

Revision 1.441.2.1558.2.94  2007/06/23 18:34:30  marcus
- fix

Revision 1.441.2.1558.2.93  2007/06/23 18:30:16  marcus
- updated nvidia sata & ethernet drivers

Revision 1.441.2.1558.2.92  2007/05/31 22:24:27  marcus
- added 3ware 9650 support

Revision 1.441.2.1558.2.91  2007/05/31 08:39:13  arekm
- up to 2.6.16.52

Revision 1.441.2.1558.2.90  2007/05/09 08:18:30  glen
- grsec was updated already

Revision 1.441.2.1558.2.89  2007/05/09 06:13:27  adamg
- 2.6.16.51

Revision 1.441.2.1558.2.88  2007/05/03 23:02:04  glen
- create and remove same symlink in -headers

Revision 1.441.2.1558.2.87  2007/05/03 22:58:33  adamg
- 2.6.16.50

Revision 1.441.2.1558.2.86  2007/04/23 07:59:47  arekm
- up to 2.6.16.49

Revision 1.441.2.1558.2.85  2007/04/22 18:28:34  qboosh
- xen builds on x86_64; fixed unresolved symbols in xen-3.0 patch

Revision 1.441.2.1558.2.84  2007/04/16 04:58:28  adamg
- 2.6.16.48

Revision 1.441.2.1558.2.83  2007/04/15 22:12:26  glen
- 2.6.16.47

Revision 1.441.2.1558.2.82  2007/04/01 11:53:54  glen
- todo: grsec_full

Revision 1.441.2.1558.2.81  2007/04/01 11:11:59  adamg
- updated to 2.6.16.46
- reiser4 patch updated

Revision 1.441.2.1558.2.80  2007/03/27 12:56:52  glen
- 2.6.16.45

Revision 1.441.2.1558.2.79  2007/03/21 07:24:16  arekm
- 2.6.16.44

Revision 1.441.2.1558.2.78  2007/03/08 07:35:13  arekm
- up to 2.6.16.43.

Revision 1.441.2.1558.2.77  2007/03/05 21:30:22  glen
- do not disable strip/chrpath globally, but only by path

Revision 1.441.2.1558.2.76  2007/02/26 07:31:05  arekm
- up to 2.6.16.42

Revision 1.441.2.1558.2.75  2007/02/18 09:32:07  arekm
- up to 2.6.16.41

Revision 1.441.2.1558.2.74  2007/02/16 11:11:02  glen
- drop bogus todo

Revision 1.441.2.1558.2.73  2007/02/15 14:23:20  glen
- more unpackaged files TODO

Revision 1.441.2.1558.2.72  2007/02/15 14:19:04  glen
- some unpackaged files detected on ac-ppc

Revision 1.441.2.1558.2.71  2007/02/15 14:16:15  charles
- enabled layer7 (-layer7-2.2.patch commited)

Revision 1.441.2.1558.2.70  2007/02/15 09:35:59  glen
- disable layer7 patch (patch not in cvs)

Revision 1.441.2.1558.2.69  2007/02/15 04:56:07  charles
- added -layer7-2.2.patch (missing?)

Revision 1.441.2.1558.2.68  2007/02/14 18:59:36  glen
- 2.6.16.40 release

Revision 1.441.2.1558.2.67  2007/02/09 15:48:51  glen
- spelling

Revision 1.441.2.1558.2.66  2007/02/09 14:43:39  arekm
- move /lib/modules/*/build symlink to proper package

Revision 1.441.2.1558.2.65  2007/02/02 10:16:29  arekm
- up to 2.6.16.39

Revision 1.441.2.1558.2.64  2007/01/23 19:58:16  arekm
- add SB600 support to ahci (backport)

Revision 1.441.2.1558.2.63  2007/01/23 10:20:09  hawk
- fixed /usr/src/linux symlink disappearing

Revision 1.441.2.1558.2.62  2007/01/21 17:52:34  hawk
- updated to 2.6.16.38

Revision 1.441.2.1558.2.61  2007/01/12 09:03:19  zbyniu
- support for capability context from vserver in selinux

Revision 1.441.2.1558.2.60  2006/12/29 17:46:43  arekm
- up to 2.6.16.37

Revision 1.441.2.1558.2.59  2006/12/22 12:33:03  zbyniu
- we have more capabilities in kernel, support in grsecurity and apparmor added
- rel 2

Revision 1.441.2.1558.2.58  2006/12/15 19:02:58  glen
- use macros for same location to be able to merge different kernel specs

Revision 1.441.2.1558.2.57  2006/12/14 00:20:04  adamg
- updated to 2.6.16.36

Revision 1.441.2.1558.2.56  2006/12/11 20:42:15  zbyniu
- apparmor support

Revision 1.441.2.1558.2.55  2006/12/08 11:24:32  cieciwa
- _rel 2,
- updated ipp2p to version 0.8.2.

Revision 1.441.2.1558.2.54  2006/12/07 17:35:06  glen
- typo

Revision 1.441.2.1558.2.53  2006/12/07 17:34:45  glen
- add ext2compiled bcond

Revision 1.441.2.1558.2.52  2006/12/07 08:24:31  adamg
- updated to 2.6.16.35 (resolves CVE-2006-5751)

Revision 1.441.2.1558.2.51  2006/12/06 20:55:00  glen
- introduce kernel_release macro for keeping versions in sync
- unify /usr/src/linux paths (/usr vs %{_prefix})

Revision 1.441.2.1558.2.50  2006/12/01 11:11:17  glen
- try hardlinking source if possible
- /usr/src/linux symlink is not packaged, so don't make it

Revision 1.441.2.1558.2.49  2006/11/30 20:22:10  glen
- BR /sbin/depmod instead of module-init-tools due vserver-packages provides module-init-tools

Revision 1.441.2.1558.2.48  2006/11/29 13:32:44  arekm
- up to 2.6.16.34

Revision 1.441.2.1558.2.47  2006/11/26 11:05:19  siefca
- added Wake-On-Lan patch for nVidia nForce ethernet driver forcedeth
- release 2

Revision 1.441.2.1558.2.46  2006/11/23 00:42:01  adamg
- updated to 2.6.16.33
- CVE-2005-4352: security/seclvl.c: fix time wrap

Revision 1.441.2.1558.2.45  2006/11/22 10:20:32  hawk
- release 2

Revision 1.441.2.1558.2.44  2006/11/21 13:52:28  hawk
- keep headers/sources in separate folders for default/grsecurity/xen
  kernels so they don't overlap and to make alt_kernel usage possible
- release 1.1, testing in progress

Revision 1.441.2.1558.2.43  2006/11/15 16:23:32  adamg
- updated to 2.6.16.32
- CVE-2006-4538: ia64/sparc: fix local DoS with corrupted ELFs

Revision 1.441.2.1558.2.42  2006/11/13 15:51:37  sparky
- don't use %{without ...}, it may not work after inverting bcond

Revision 1.441.2.1558.2.41  2006/11/12 21:57:03  adamg
- CVE notes for 2.6.16.31
- changelog cosmetics

Revision 1.441.2.1558.2.40  2006/11/11 19:37:21  adamg
- updated to 2.6.16.31
  [CVE-2006-4572, CVE-2006-5619, CVE-2006-5174]

Revision 1.441.2.1558.2.39  2006/11/03 09:24:24  adamg
- updated to 2.6.16.30; resolves CVE-2006-4997 (remote DoS when using ATM)

Revision 1.441.2.1558.2.38  2006/10/29 23:00:23  glen
- add C: vserver-packages due module-init-tools being provided by it

Revision 1.441.2.1558.2.37  2006/10/22 20:12:29  hawk
- bconded and disabled ReiserFS 4 support, for now it will not be included
  in any official Ac kernel
- fixed one typo
- release 3

Revision 1.441.2.1558.2.36  2006/09/28 21:42:55  glen
- typos (thx sparky)

Revision 1.441.2.1558.2.35  2006/09/28 21:36:26  glen
- pass %{__cc} in crossopts
- use rpm macros for crossopts and depmod

Revision 1.441.2.1558.2.34  2006/09/28 19:14:08  glen
- provide kernel-module-build %{_basever} for external module building

Revision 1.441.2.1558.2.33  2006/09/28 15:02:18  glen
- pass CC to compiler; rel 2

Revision 1.441.2.1558.2.32  2006/09/15 13:16:58  pluto
- CVE note for 2.6.16.29 release.

Revision 1.441.2.1558.2.31  2006/09/13 19:46:36  glen
- drop O/P: kernel-i2c-devel from -headers (LINUX_2_6 merge)

Revision 1.441.2.1558.2.30  2006/09/13 19:20:51  arekm
- up to 2.6.16.29
  # CVE-2006-3468: fix NFS over ext3 DoS
  # fix NFS over ext2 DoS
  # ipv6: fix oops triggerable by any user

Revision 1.441.2.1558.2.29  2006/09/02 21:37:12  paszczus
- fixed (i hope) SMP modules directory (thx to pepe (at) apollo.pl)

Revision 1.441.2.1558.2.28  2006/08/29 23:27:09  pluto
- testing CFIs for signal frames...

Revision 1.441.2.1558.2.27  2006/08/27 10:06:08  pluto
- release 1 for version .28

Revision 1.441.2.1558.2.26  2006/08/27 10:03:11  pluto
- [x86-64 only] enable stack-protector buffer overflow detection.

Revision 1.441.2.1558.2.25  2006/08/27 07:12:55  adamg
- CVE notes for 2.6.16.28

Revision 1.441.2.1558.2.24  2006/08/27 07:06:43  pluto
- squashfs updated to 3.1.

Revision 1.441.2.1558.2.23  2006/08/26 12:11:33  arekm
- up to 2.6.16.28
  [CVE-2006-2935, CVE-2006-3745, CVE-2006-4093, CVE-2006-4145]

Revision 1.441.2.1558.2.22  2006/08/19 13:08:12  adamg
- changed Provides: kernel(xen) to Provides: kernel(xen0) - xen utils
  are to be used only in dom0, so it is importrant to have proper kernel
  installed (not 'just' xen-enabled)
- typo in Provides: kernel(xen0) for -smp package

Revision 1.441.2.1558.2.21  2006/08/15 11:11:10  adamg
- hdaps_protect.patch dropped - it is provided as a kernel module by
  kernel-misc-tp_smapi.spec (and has to be, otherwise it conflicts with
  thinkpad_ec module)

Revision 1.441.2.1558.2.20  2006/08/10 14:27:25  wolvverine
- add wireless extensions patch

Revision 1.441.2.1558.2.19  2006/07/20 16:11:02  mguevara
- 2.6.16.27-2 - added pax bcond

Revision 1.441.2.1558.2.18  2006/07/17 14:18:15  pluto
- updated to 2.6.16.27.
  USB serial ftdi_sio: Prevent userspace DoS (CVE-2006-2936)

Revision 1.441.2.1558.2.17  2006/07/15 21:15:21  adamg
- 2.6.16.26

Revision 1.441.2.1558.2.16  2006/07/15 07:45:21  adamg
- updated to 2.6.16.25 (CVE-2006-3626)

Revision 1.441.2.1558.2.15  2006/07/12 12:23:06  hawk
- make bootsplash default over fbsplash
- release 1

Revision 1.441.2.1558.2.14  2006/07/07 11:56:31  havner
- bconded bootsplash added (works, tested)
- what to enable by default? fbsplash/bootsplash
- what about archs !x86?
- rel 0.1 (there were no 1 for .24 so no point in leaving 1.1)

Revision 1.441.2.1558.2.13  2006/07/06 23:44:08  adamg
- updated to 2.6.16.24, security fix:
  fix prctl privilege escalation and suid_dumpable (CVE-2006-2451)

Revision 1.441.2.1558.2.12  2006/07/02 17:44:15  havner
- vesafb-tng bconded, and default turned off, it doesn't work on every
  machine and turns off default vesafb code so its impossible to get any
  working framebuffer.
- rel 1.1

Revision 1.441.2.1558.2.11  2006/07/01 08:35:55  pluto
- updated to 2.6.16.23 (CVE-2006-2934 fix included).

Revision 1.441.2.1558.2.10  2006/06/30 18:59:19  adamg
- backported from 2.6.17.3:
   NETFILTER: SCTP conntrack: fix crash triggered by packet without chunks

Revision 1.441.2.1558.2.9  2006/06/30 12:54:39  jajcus
- initrd and bootloader configuration update disabled in %post of kernel-xenU-smp

Revision 1.441.2.1558.2.8  2006/06/30 12:51:34  jajcus
- nicer /boot symlinks names (e.g. vmlinuz-xen0 instead of vmlinuzxen0)

Revision 1.441.2.1558.2.7  2006/06/30 12:27:26  jajcus
- Release: 3
- Xen bconds made work
- files, dirs and symlinks renamed in Xen kernels, so non-Xen, Xen0 and XenU
  kernels may coexist in one system

Revision 1.441.2.1558.2.6  2006/06/26 09:35:11  pluto
- fix radi5 bug, release 2.

Revision 1.441.2.1558.2.5  2006/06/25 16:56:54  adamg
- cluster dir (for kernel-cluster-{cman,dlm})

Revision 1.441.2.1558.2.4  2006/06/23 08:27:37  pluto
- updated to 2.6.16.22.

Revision 1.441.2.1558.2.3  2006/06/22 13:15:08  areq
- patch for hp dc7600 (alsa bug #2157)

Revision 1.441.2.1558.2.2  2006/06/21 20:23:29  pluto
- fix critical ntfs bug.

Revision 1.441.2.1558.2.1  2006/06/21 20:14:10  pluto
- updated to 2.6.16.21 (fix CVE-2006-2445, CVE-2006-3085, s (CVE-2006-2).

Revision 1.441.2.1558  2006/06/17 11:40:50  hawk
- make TuneUpConfigForIX86 always return 0, fixes build on i386

Revision 1.441.2.1557  2006/06/14 22:50:37  adamg
- typo

Revision 1.441.2.1556  2006/06/13 22:01:51  sparky
- killed black magic in file collecting, moved to final of %install

Revision 1.441.2.1555  2006/06/05 18:24:23  pluto
- updated to 2.6.16.20.

Revision 1.441.2.1554  2006/05/31 06:53:33  pluto
- updated to 2.6.16.19.
  fix small information leak in netfilter (CVE-2006-1343).

Revision 1.441.2.1553  2006/05/27 13:07:12  zergin
- added Patch1: PATA ports on Promise SATA controllers
  builds, works, tested.

Revision 1.441.2.1552  2006/05/26 15:17:09  baggins
- apply patch 102

Revision 1.441.2.1551  2006/05/26 15:13:20  baggins
- rel 1.1
- updated vserver to 2.1.1-rc21

Revision 1.441.2.1550  2006/05/24 10:11:36  qboosh
- cleanup, R(post) for base and -smp

Revision 1.441.2.1549  2006/05/22 21:22:30  pluto
- updated to 2.6.16.18.
  fixes CVE-2006-2444 - potential remote DoS in SNMP NAT helper.

Revision 1.441.2.1548  2006/05/21 08:37:44  cieciwa
- updated to 2.6.16.17,
- _release 0.1,
- updated MD5 sum,
- - FIXED:
    [PATCH] SCTP: Validate the parameter length in HB-ACK chunk (CVE-2006-1857)
    [PATCH] SCTP: Respect the real chunk length when walking parameters (CVE-2006-1858)
    [PATCH] ptrace_attach: fix possible deadlock schenario with irqs
    [PATCH] Fix ptrace_attach()/ptrace_traceme()/de_thread() race
    [PATCH] page migration: Fix fallback behavior for dirty pages
    [PATCH] add migratepage address space op to shmem
    [PATCH] Remove cond_resched in gather_stats()
    [PATCH] VIA quirk fixup, additional PCI IDs
    [PATCH] PCI quirk: VIA IRQ fixup should only run for VIA southbridges
    [PATCH] Fix udev device creation
    [PATCH] limit request_fn recursion
    [PATCH] PCI: correctly allocate return buffers for osc calls
    [PATCH] selinux: check for failed kmalloc in security_sid_to_context()
    [PATCH] TG3: ethtool always report port is TP.
    [PATCH] Netfilter: do_add_counters race, possible oops or info leak (CVE-2006-0039)
    [PATCH] scx200_acb: Fix resource name use after free
    [PATCH] smbus unhiding kills thermal management
    [PATCH] fs/compat.c: fix 'if (a |= b )' typo
    [PATCH] smbfs: Fix slab corruption in samba error path
    [PATCH] fs/locks.c: Fix sys_flock() race
    [PATCH] USB: ub oops in block_uevent
    [PATCH] via-rhine: zero pad short packets on Rhine I ethernet cards
    [PATCH] md: Avoid oops when attempting to fix read errors on raid10

Revision 1.441.2.1547  2006/05/19 22:14:06  mguevara
- rel 3 - new version of grsecurity-2.1.9-2.6.16.14.patch, fixes
  "Badness in local_bh_enable at kernel/softirq.c:144" in grsec_full
  enabled kernels

Revision 1.441.2.1546  2006/05/19 16:41:10  glen
- cleanup backups in %prep stage

Revision 1.441.2.1545  2006/05/16 19:10:34  pluto
- adjust sourceX.

Revision 1.441.2.1544  2006/05/16 19:00:49  pluto
- release 2.

Revision 1.441.2.1543  2006/05/16 17:40:23  pluto
- new way of collecting files for module-build subpkg.

Revision 1.441.2.1542  2006/05/12 19:57:34  pluto
- regparm bcond disappeard, release 1.

Revision 1.441.2.1541  2006/05/12 15:50:04  paszczus
- updated to 2.6.16.16

Revision 1.441.2.1540  2006/05/10 13:25:39  baggins
- rel 0.1
- updated to 2.6.16.15
- updated XEN configs
- fixed sparc configs
- tested (works) on: ix86, sparc, sparc64

Revision 1.441.2.1539  2006/05/08 16:56:00  baggins
- fix nfsroot bcond

Revision 1.441.2.1538  2006/05/08 16:54:40  baggins
- added nfsroot bcond

Revision 1.441.2.1537  2006/05/08 08:11:21  baggins
- disabled suspend2 on ppc, looks b0rken on this arch

Revision 1.441.2.1536  2006/05/07 22:58:07  baggins
- experimental hacks to get kernel to compile on ppc with gcc 3.3

Revision 1.441.2.1535  2006/05/07 20:18:50  baggins
- enabled grsec_minimal patching
- added pae bcond for building PAE kernel on uniprocessor

Revision 1.441.2.1534  2006/05/07 10:38:59  zbyniu
- grsecurity-2.1.9-2.6.16.14.patch not conflicting with vserver; rel 0.3

Revision 1.441.2.1533  2006/05/06 23:33:30  baggins
- rel 0.2

Revision 1.441.2.1532  2006/05/06 23:09:09  baggins
- math-emu re-enabled for i586 (for eg. Nx586 and all curious cpus).

Revision 1.441.2.1531  2006/05/06 22:56:09  baggins
- disable math emulation also on i586
- disable HIGHMEM64G on uniprocessor because there are recent Pentium-M
  processors (some of Sonoma core, at least) that do not have PAE,
  and I don't believe anyone have more than 4GB RAM on UP hardware

Revision 1.441.2.1530  2006/05/05 22:31:15  baggins
- fix alpha/sparc/sparc64 compilation

Revision 1.441.2.1529  2006/05/05 15:37:17  baggins
- fix compilation on non PM capable archs

Revision 1.441.2.1528  2006/05/05 15:29:14  baggins
- resolved suspend2/vserver problem of missing definitions

Revision 1.441.2.1527  2006/05/05 14:27:44  baggins
- suspend2 2.2.5

Revision 1.441.2.1526  2006/05/05 14:00:08  baggins
- added XOR and unclean netfilter modules

Revision 1.441.2.1525  2006/05/05 13:54:39  baggins
- sort out patches and ifarchs

Revision 1.441.2.1524  2006/05/05 13:48:59  baggins
- up to 2.6.16.14

Revision 1.441.2.1523  2006/05/05 13:45:37  baggins
- hack removal

Revision 1.441.2.1522  2006/05/05 13:19:46  baggins
- removed bconds: preemptive, suspend2, vserver
  now these features are enabled unconditionally, preempt as built in
  CONFIG_PREEMPT_VOLUNTARY and CONFIG_PREEMPT_BKL
  Rationale: These features are non-intrusive and have no noticable impac
             on kernel performance, thus having them on bconds is unnecessary
             complicating build process.

Revision 1.441.2.1521  2006/05/04 08:11:21  cieciwa
- updated to 2.6.16.13,
- updated MD5 sum,
- netfilter up to 20060504 snap.
  NFY.

Revision 1.441.2.1520  2006/05/02 19:09:25  paszczus
- updated to 2.6.16.12 ; removed linux-2.6-alpha-for_each_possible_cpu (applied in sources)

Revision 1.441.2.1519  2006/04/30 18:40:01  sparky
- added iforce-trust_ffrm patch

Revision 1.441.2.1518  2006/04/28 14:48:31  baggins
- fix compilation on alpha

Revision 1.441.2.1517  2006/04/28 13:05:56  baggins
- rel 4
- official fix for vserver privilege escalation

Revision 1.441.2.1516  2006/04/27 12:47:10  baggins
- rel 3
- vserver fixed properly

Revision 1.441.2.1515  2006/04/27 10:02:23  baggins
- release 2
- fixed security issue with vserver context capabilities

Revision 1.441.2.1514  2006/04/26 11:04:41  cieciwa
- fixen xen type in package name.

Revision 1.441.2.1513  2006/04/26 10:34:39  cieciwa
- updated for Xen.

Revision 1.441.2.1512  2006/04/25 07:39:59  paszczus
- updated to 2.6.16.11
- added warning about OldWorldMacs
- cleanups, typos

Revision 1.441.2.1511  2006/04/24 22:55:07  glen
- cleanups and unify

Revision 1.441.2.1510  2006/04/24 18:23:10  adamg
- updated to 2.6.16.10

Revision 1.441.2.1509  2006/04/23 14:33:38  glen
- tabs

Revision 1.441.2.1508  2006/04/23 14:30:32  glen
- fix unbalanced conditional

Revision 1.441.2.1507  2006/04/23 12:13:05  adamg
- dropped vesafb-tng bcond - vesafb-tng can be disabled with
  'video=vesafb:off' kernel parameter (and other modules will work then)

Revision 1.441.2.1506  2006/04/23 09:18:46  pluto
- disable vesafb_tng module by default.

Revision 1.441.2.1505  2006/04/23 09:09:17  pluto
- release 1.

Revision 1.441.2.1504  2006/04/21 08:35:26  adamg
- release 0.6 (with i386{,-smp} configs fixed)

Revision 1.441.2.1503  2006/04/20 14:07:57  baggins
- rel 0.5
- updated vserver to 2.1.1-rc17
- fixed suspend2 patch

Revision 1.441.2.1502  2006/04/20 12:44:01  baggins
- suspend2 updated to 2.2.4.2

Revision 1.441.2.1501  2006/04/20 08:30:52  cieciwa
- _rel 0.4,
- added grsecurity patch.

Revision 1.441.2.1500  2006/04/19 20:59:15  baggins
- rel 0.3
- cleaned up and updated ix86 and x86_86 configs

Revision 1.441.2.1499  2006/04/19 15:13:22  baggins
- rel 0.2

Revision 1.441.2.1498  2006/04/19 15:12:53  baggins
- provide kernel(xen) only if it's compiled in

Revision 1.441.2.1497  2006/04/19 15:08:18  baggins
- disable HIGHMEM64GB on anything below i686

Revision 1.441.2.1496  2006/04/19 14:40:26  baggins
- athlon does not need math emulation

Revision 1.441.2.1495  2006/04/19 13:26:04  pluto
- don't use uri for patches stored in cvs.

Revision 1.441.2.1494  2006/04/19 12:09:58  cieciwa
- added Provides: kernel(xen) = %{_xen_version} - in this moment 3.0.2.

Revision 1.441.2.1493  2006/04/19 12:05:51  cieciwa
- Xen 3.0.2 added.

Revision 1.441.2.1492  2006/04/19 07:51:59  cieciwa
- updated to 2.6.16.9 - [PATCH] i386/x86-64: Fix x87 information leak between processes (CVE-2006-1056),
- updated MD5 sum.

Revision 1.441.2.1491  2006/04/18 22:31:51  baggins
- 2.6.16.8

Revision 1.441.2.1490  2006/04/18 12:46:19  cieciwa
- updated to 2.6.16.7,
- updated MD5 sum.

Revision 1.441.2.1489  2006/04/17 16:40:13  paszczus
- partialy adaptarized

Revision 1.441.2.1488  2006/04/12 22:31:27  baggins
- fixed patch60

Revision 1.441.2.1487  2006/04/12 22:20:09  adamg
- disable patch60 for now (breaks build)

Revision 1.441.2.1486  2006/04/12 21:26:12  adamg
- updated to 2.6.16.5

Revision 1.441.2.1485  2006/04/12 19:59:43  baggins
- fixed rpm macro defs

Revision 1.441.2.1484  2006/04/12 19:42:46  baggins
- nasty hack in defconfig for vserver build

Revision 1.441.2.1483  2006/04/12 17:01:18  baggins
- release 1.8
- added latest syskonnect patch
- fixed netfilter patches

Revision 1.441.2.1482  2006/04/12 15:55:50  baggins
- skip double grsec patching

Revision 1.441.2.1481  2006/04/12 15:36:49  baggins
- rel 1.7
- added minimal grsecurity
- only add -grsecurity suffix to package name if we build full grsecurity

Revision 1.441.2.1480  2006/04/11 20:47:16  cieciwa
- _rel 1.6,
  added ACCOUNT and accouont netfilter module.

Revision 1.441.2.1479  2006/04/11 18:27:05  baggins
- rel 1.5

Revision 1.441.2.1478  2006/04/11 18:25:45  baggins
- 2.6.16.4

Revision 1.441.2.1477  2006/04/11 18:23:01  baggins
- updated vserver to 2.1.1-rc15

Revision 1.441.2.1476  2006/04/11 12:43:00  cieciwa
- _rel 1.2.

Revision 1.441.2.1475  2006/04/11 12:34:50  cieciwa
- added ROUTE netfilter module.

Revision 1.441.2.1474  2006/04/11 12:28:43  cieciwa
- added IPMARK netfilter module.

Revision 1.441.2.1473  2006/04/11 12:22:25  cieciwa
- added rpm netfilter module.

Revision 1.441.2.1472  2006/04/11 11:52:42  cieciwa
- netfilter TARPIT module added.

Revision 1.441.2.1471  2006/04/11 11:26:26  cieciwa
- _rel 1.1,
- added ATM patches.

Revision 1.441.2.1470  2006/04/10 06:37:21  cieciwa
- _rel 1,
  STBR - TH

Revision 1.441.2.1469  2006/04/07 22:08:39  cieciwa
- updated MD5 sum.

Revision 1.441.2.1468  2006/04/07 20:45:57  cieciwa
- version 2.6.16.2
- _rel 0.1

Revision 1.441.2.1467  2006/04/07 09:04:50  cieciwa
- _rel 0.6,
- Kconfig files moved from source to modules-build subpackage.

Revision 1.441.2.1466  2006/04/07 08:15:21  cieciwa
- working on sources/module-build.
  NFY.

Revision 1.441.2.1465  2006/04/07 07:58:25  cieciwa
- added esfq [current version].
  NFY

Revision 1.441.2.1464  2006/04/07 06:44:42  cieciwa
- typo ?

Revision 1.441.2.1463  2006/04/06 08:20:21  cieciwa
- added ipp2p support.

Revision 1.441.2.1462  2006/04/06 05:49:07  adamg
- bcond for disabling vesafb-tng patch (it is compiled in statically
  and breaks other modules, on the other hand it supports high resolutions
  like 1400x1050-32
- fixed path for suspend2
- hdaps_protect.patch applied (adds support for for thinkpad's disk
  protection systems

Revision 1.441.2.1461  2006/04/04 19:50:14  cieciwa
- _rel 0.5,
- added vesafb-tng config [ix86 only]

Revision 1.441.2.1460  2006/04/04 13:39:18  qboosh
- readded my patches (alpha-isa, fbcon-margins, static-dev)

Revision 1.441.2.1459  2006/04/04 08:16:24  cieciwa
- vesafb-tng patch applayed.

Revision 1.441.2.1458  2006/04/04 08:03:33  cieciwa
- _rel 0.4,
- added scripts/kconfig to module-build package.

Revision 1.441.2.1457  2006/04/04 07:47:57  cieciwa
- added patch from http://bluetooth-alsa.sourceforge.net/

Revision 1.441.2.1456  2006/04/03 21:43:47  blekot
- added linux-2.6-vesafb-tng.patch from gentoo
- fb working on nvidia with nvidia binary packages
- swiching from X to console is working too
- bootsplash (fbsplash) not tested yet
- TODO: configs needs to be updated

Revision 1.441.2.1455  2006/03/31 17:50:04  cieciwa
- _rel 0.3,
- IMQ applayed.

Revision 1.441.2.1454  2006/03/30 08:19:55  cieciwa
- _rel 0.2,
- added source, applayed and bcond for vserver,
- added source for grsecurity [applayed brooken].

Revision 1.441.2.1453  2006/03/29 13:12:04  cieciwa
- updated to 2.6.16.1,
- updated MD5 sum,
- _rel 0.1,
- fixed netfilter ipv6 modules: fuzzy, nth, random.

Revision 1.441.2.1452  2006/03/29 09:30:30  cieciwa
- fixed netfilter patches numbering.

Revision 1.441.2.1451  2006/03/29 08:03:01  cieciwa
- _rel 0.9,
- netfilter snap 20060329,
- netfilter modules in separated patch.

Revision 1.441.2.1450  2006/03/28 12:46:20  cieciwa
- _rel 0.8,
- removed from netfilter brooken module,
- added reiserfs4.

Revision 1.441.2.1449  2006/03/28 11:06:23  cieciwa
- copy kernel-%arch.config to default config.

Revision 1.441.2.1448  2006/03/28 09:10:41  cieciwa
- _rel 0.7,
- updated netfilter to snap 2006-03-28.

Revision 1.441.2.1447  2006/03/26 15:36:52  sparky
- no kernel-libs on ppc for now, seems to be broken, PREP if marked as broken,
  there is no zImage.{chrp,chrp-rs6k}, I don't know what zImage.vmode is...

Revision 1.441.2.1446  2006/03/25 17:53:39  paszczus
- updated PPC build.

Revision 1.441.2.1445  2006/03/24 14:22:08  paszczus
- update binutils version

Revision 1.441.2.1444  2006/03/24 13:40:28  cieciwa
- _rel 0.6.

Revision 1.441.2.1443  2006/03/24 11:16:17  cieciwa
- clearing temp commands.

Revision 1.441.2.1442  2006/03/24 10:56:41  paszczus
- fixed ppc build config.

Revision 1.441.2.1441  2006/03/24 08:58:00  cieciwa
- PPC64 more fixes ...

Revision 1.441.2.1440  2006/03/24 08:36:18  cieciwa
- PPC64 kernel config build - test !!

Revision 1.441.2.1439  2006/03/23 09:31:02  cieciwa
- _rel 0.5,
- added fbsplash.

Revision 1.441.2.1438  2006/03/22 17:47:23  cieciwa
- fixed suspend.

Revision 1.441.2.1437  2006/03/22 12:19:19  cieciwa
- _rel 0.4,
- added Tahoe9XX support.

Revision 1.441.2.1436  2006/03/22 11:57:14  cieciwa
- re-added kernel-ppclibs.Makefile for %arch==ppc.

Revision 1.441.2.1435  2006/03/22 11:43:12  cieciwa
- _rel 0.3.2,
- updated suspend2 applayed sources process.

Revision 1.441.2.1434  2006/03/22 11:27:20  cieciwa
- _rel 0.3.1.

Revision 1.441.2.1433  2006/03/22 11:17:38  cieciwa
- suspend2 code applayed,
- added configuration file.

Revision 1.441.2.1432  2006/03/22 10:54:32  cieciwa
- _rel 0.3,
- added bcond suspend2,
- added suspend2 source [not applied YET].
  NFY

Revision 1.441.2.1431  2006/03/22 09:41:56  cieciwa
- added linux-kbuild-extmod.patch as patch0.

Revision 1.441.2.1430  2006/03/21 21:13:10  cieciwa
- fixed preemptive bcond description.

Revision 1.441.2.1429  2006/03/21 13:12:17  cieciwa
- added SquashFS support.

Revision 1.441.2.1428  2006/03/21 12:25:06  cieciwa
- _rel 0.2,
- bconded preemptive.

Revision 1.441.2.1427  2006/03/21 09:57:13  cieciwa
- _rel 0.1.

Revision 1.441.2.1426  2006/03/21 09:38:09  cieciwa
- small info added.

Revision 1.441.2.1425  2006/03/21 09:06:38  cieciwa
- fixed changelog.

Revision 1.441.2.1424  2006/03/21 08:26:08  cieciwa
- removed FAQ from doc.

Revision 1.441.2.1423  2006/03/20 15:08:22  qboosh
- no Source6 now

Revision 1.441.2.1422  2006/03/20 15:07:39  qboosh
- Linux 2.6.16 requires gcc >= 3.2

Revision 1.441.2.1421  2006/03/20 13:10:33  cieciwa
- updated/fixed

Revision 1.441.2.1420  2006/03/20 12:06:31  cieciwa
- version 2.6.16,
- _rel 0.0,
- updated MD5 sum,
- removing ALL patches,
- cuting changelog.
  NFY.
